-- Tested with a lvl60 tier2 priest in UBRS/MC/BWL/AQ20/AQ40

HealBot_Action_HealGroup = {
  "player",
  "pet",
  "party1",
  "party2",
  "party3",
  "party4",
};

HealBot_Action_HealTarget = {
};

HealBot_Action_HealButtons = {
};

HealBot_Action_UnitButtons = {
};

function HealBot_Action_AddDebug(msg)
  HealBot_AddDebug("Action: " .. msg);
end

function HealBot_HealthColor(unit)
--  local pct = UnitHealth(unit)/UnitHealthMax(unit);
  local text = UnitName(unit);
  
  if not HealBot_HealsIn[text] then
    HealBot_ResetHealsIn()
  end
  local pct = UnitHealth(unit)+HealBot_HealsIn[text];
  if pct<UnitHealthMax(unit) then
   pct=pct/UnitHealthMax(unit);
  else
    pct=1;
  end
  
  local r,g,b = 1.0, 1.0, 0.0;
  if pct>=0.90 then r = 0.0; end
  if pct<0.90 and pct>=0.57 then r=2.7-(pct*3); end 
  if pct<0.54 and pct>0.21 then g=(pct-0.21)*3; end 
  if pct<=0.21 then g = 0.0; end
  return r,g,b,HealBot_BarAlpha;
end

function HealBot_Action_HealthBar(button)
  local name = button:GetName();
  return getglobal(name.."Bar");
end

function HealBot_AlwaysHeal()
  return HealBot_EnableHealthy==1 or IsShiftKeyDown() or IsControlKeyDown() or IsAltKeyDown() or HealBot_Debug
end

function HealBot_MayHeal(unit)
  if not UnitName(unit) or not HealBot_Heals[unit] then return false end
  if unit ~= 'target' then return true end
  if not HealBot_TargetHeals or UnitCanAttack("player",unit) then return false end
  return true;
end

function HealBot_ShouldHeal(unit)
  return HealBot_MayHeal(unit) and UnitHealth(unit)>0 and not UnitIsDeadOrGhost(unit)
    and (UnitHealth(unit)<UnitHealthMax(unit)*HealBot_HealthPct or HealBot_AlwaysHeal());
end

function HealBot_Action_ShouldHealSome()
  return table.foreach(HealBot_Action_HealButtons, function (index,button)
    if (HealBot_ShouldHeal(button.unit)) then return button.unit; end
  end);
end

function HealBot_MustHeal(unit)
  return HealBot_ShouldHeal(unit) and UnitHealth(unit)<UnitHealthMax(unit)*HealBot_AlertLevel
end

function HealBot_Action_MustHealSome()
  return table.foreach(HealBot_Action_HealButtons, function (index,button)
    if (HealBot_MustHeal(button.unit)) then return button.unit; end
  end);
end

function HealBot_CanHeal(unit)
  return HealBot_ShouldHeal(unit) and HealBot_GetHealSpell(unit,HealBot_Action_SpellPattern());
end

function HealBot_Action_EnableButton(button)
  if (not HealBot_IsCasting and HealBot_CanHeal(button.unit)) then
    button:Enable();
  else
    button:Disable();
  end
end

function HealBot_Action_EnableButtons()
  table.foreach(HealBot_Action_HealButtons, function (index,button)
    HealBot_Action_EnableButton(button);
  end);
end

function HealBot_Action_RefreshButton(button)
  if not button then return end
  if type(button)~="table" then DEFAULT_CHAT_FRAME:AddMessage("***** "..type(button)) end
  local unit = button.unit;
  if HealBot_MayHeal(unit) then
    local bar = HealBot_Action_HealthBar(button);
    bar:SetMinMaxValues(0,UnitHealthMax(unit));
    bar:SetValue(UnitHealth(unit));
    bar:SetStatusBarColor(HealBot_HealthColor(unit));

    local text = UnitName(unit);
--    if string.len(text)>15 then
--      text = string.sub(text,1,15) .. '...';
--    end
--    local secs = HealBot_UnitTTL(unit);
--    if secs>0 and secs<=HealBot_AlertSeconds then
--      text = text .. ' (' .. secs .. ')';
--    end
    button:SetText(text);
 
    HealBot_Action_EnableButton(button)
  end
end

function HealBot_Action_RefreshButtons()
  table.foreach(HealBot_Action_HealButtons, function (index,button)
    HealBot_Action_RefreshButton(button);
  end);
end

function HealBot_Action_RefreshButtons(unit)
  if unit and HealBot_Action_UnitButtons[unit] then
    table.foreach(HealBot_Action_UnitButtons[unit], function (index,button)
      HealBot_Action_RefreshButton(button);
    end);
  else
    table.foreach(HealBot_Action_HealButtons, function (index,button)
      HealBot_Action_RefreshButton(button);
    end);
  end
end

function HealBot_Action_PositionButton(button,offset)
  local unit = button.unit;
  button:SetText(UnitName(unit) or (string.upper(string.sub(unit,1,1)) .. string.sub(unit,2)));
  if (HealBot_MayHeal(unit)) then
    button:Show();
    button:ClearAllPoints();
    button:SetPoint("TOP","HealBot_Action","TOP",0,-offset);
    offset = offset+button:GetHeight()+6;
  else
    button:Hide();
  end
  return offset;
end

function HealBot_Action_SetHeight(height)
  if HealBot_ActionHeight then
    HealBot_Action:SetHeight(HealBot_ActionHeight);
  end
  if HealBot_GrowUpwards==1 then
    local left,bottom = HealBot_Action:GetLeft(),HealBot_Action:GetBottom();
    if left and bottom then
      HealBot_Action:ClearAllPoints();
      HealBot_Action:SetPoint("BOTTOMLEFT","UIParent","BOTTOMLEFT",left,bottom);
    end
  else
    local left,top = HealBot_Action:GetLeft(),HealBot_Action:GetTop();
    if left and top then
      HealBot_Action:ClearAllPoints();
      HealBot_Action:SetPoint("TOPLEFT","UIParent","BOTTOMLEFT",left,top);
    end
  end
  HealBot_Action:SetHeight(height);
  HealBot_ActionHeight = height;
end

function HealBot_Action_SetHealButton(index,unit)
  if not index then
    HealBot_Action_HealButtons = {};
    HealBot_Action_UnitButtons = {};
    return nil
  end
  local button = getglobal("HealBot_Action_HealUnit"..index);
  button.unit = unit;
  if unit then
    table.insert(HealBot_Action_HealButtons,button);
    if not HealBot_Action_UnitButtons[unit] then HealBot_Action_UnitButtons[unit] = {} end
    table.insert(HealBot_Action_UnitButtons[unit],button);
  else
    button:Hide();
  end
  return button;
end

function HealBot_Action_PartyChanged()
  HealBot_Action_SetHealButton();
  local i = 0;
  local last = 0;
  last = last+6
  if HealBot_GroupHeals==1 then
    for _,unit in ipairs(HealBot_Action_HealGroup) do
      if not HealBot_Action_UnitButtons[unit] and HealBot_MayHeal(unit) then
        i = i+1;
        HealBot_Action_SetHealButton(i,unit);
      end
      if i==last then break end
    end
  end
  while i<last do
    i = i+1;
    HealBot_Action_SetHealButton(i,nil);
  end

  last = last+10
  if HealBot_TankHeals==1 then
    if GetNumRaidMembers()>0 and HealBot_IntegrateCTRA==1 then
      for j=1,10 do
        if CT_RA_MainTanks[j] then
          for k=1,GetNumRaidMembers() do
            local unit = "raid"..k;
            local PossibleMT=1;
            if UnitInParty(unit) and HealBot_GroupHeals==1 then 
              if not UnitIsUnit(unit, "player") then
                PossibleMT=0;
              end
            end
            if PossibleMT==1 then 
              if UnitName(unit)==CT_RA_MainTanks[j] then
                if not HealBot_Action_UnitButtons[unit] and HealBot_MayHeal(unit) then
                  i = i+1;
                  HealBot_Action_SetHealButton(i,unit);
                end
              end
            end
          end
        end
      if i==last then break end
      end
    end
  end
  while i<last do
    i = i+1;
    HealBot_Action_SetHealButton(i,nil);
  end

  last = last+4;
  if HealBot_TargetHeals==1 then
    for _,unit in ipairs(HealBot_Action_HealTarget) do
      if not HealBot_Action_UnitButtons[unit] and HealBot_MayHeal(unit) then
        i = i+1;
        HealBot_Action_SetHealButton(i,unit);
        local check = getglobal("HealBot_Action_HealUnit"..i.."Check");
        check.unit = unit;
        check:SetChecked(1);
        check:Show();
      end
      if i==last then break end
    end

    last = last+1
    unit = HealBot_TargetName()
    if not HealBot_Action_UnitButtons[unit] and HealBot_MayHeal("target") then
      i = i+1;
      HealBot_Action_SetHealButton(i,"target");
      local check = getglobal("HealBot_Action_HealUnit"..i.."Check");

      check:SetChecked(0);
      check.unit = unit;
      if check.unit and i<last then
        check:Show();
      else
        check:Hide();
      end
    end
  end
  while i<last do
    i = i+1;
    HealBot_Action_SetHealButton(i,nil);
  end

  last = last+5
  if HealBot_EmergencyHeals==1 then
    local order = {};
    local units = {};

    if HealBot_EmergIncMonitor==1 then
      if GetNumRaidMembers()>0 then
        for j=1,40 do
          local PossibleEmerg=1;
          local unit = "raid"..j;
            if UnitInParty(unit) and HealBot_GroupHeals==1 then
              PossibleEmerg=0;
            end
          if PossibleEmerg==1 then 
            if HealBot_EmergRange==1 then
              if not HealBot_Action_UnitButtons[unit] and HealBot_MustHeal(unit) then
                if UnitHealth(unit)<UnitHealthMax(unit)*HealBot_EmergencyLevel then
                  if HealBot_Range_Check(unit, 40)==1 then
     				if HealBot_EmergencySort==1 then
                      order[unit] = UnitHealth(unit);
                    elseif HealBot_EmergencySort==2 then
                      order[unit] = UnitHealth(unit)/UnitHealthMax(unit);
                    else
                      order[unit] = HealBot_UnitTTL(unit);
                    end
                    table.insert(units,unit);
                  end
                end              
              end
            else
              if not HealBot_Action_UnitButtons[unit] and HealBot_MustHeal(unit) then
                if UnitHealth(unit)<UnitHealthMax(unit)*HealBot_EmergencyLevel then
                  if HealBot_EmergencySort==1 then
                    order[unit] = UnitHealth(unit);
                  elseif HealBot_EmergencySort==2 then
                    order[unit] = UnitHealth(unit)/UnitHealthMax(unit);
                  else
                    order[unit] = HealBot_UnitTTL(unit);
                  end
                  table.insert(units,unit);
                end
              end
            end
          end
        end
      else
        for _,unit in ipairs(HealBot_Action_HealGroup) do
          if not HealBot_Action_UnitButtons[unit] and HealBot_MustHeal(unit) then
            if UnitHealth(unit)<UnitHealthMax(unit)*HealBot_EmergencyLevel then
              order[unit] = UnitHealth(unit);
              table.insert(units,unit);
            end
          end
        end
      end
    else
      if GetNumRaidMembers()>0 then
        for j=1,40 do

          local unit = "raid"..j;
          local englishClass = HealBot_UnitClass(unit);
          local ProcessUnit = 0;
          local PossibleEmerg=1;

          if 
             englishClass=="WARRIOR" and HealBot_EmergIncWarrior==1 then ProcessUnit = 1;
          elseif  
             englishClass=="ROGUE" and HealBot_EmergIncRogue==1 then ProcessUnit = 1;
          elseif  
             englishClass=="HUNTER" and HealBot_EmergIncHunter==1 then ProcessUnit = 1;
          elseif  
             englishClass=="WARLOCK" and HealBot_EmergIncWarlock==1 then ProcessUnit = 1;
          elseif  
             englishClass=="MAGE" and HealBot_EmergIncMage==1 then ProcessUnit = 1;
          elseif  
             englishClass=="PALADIN" and HealBot_EmergIncPaladin==1 then ProcessUnit = 1;
          elseif  
             englishClass=="DRUID" and HealBot_EmergIncDruid==1 then ProcessUnit = 1;
          elseif  
             englishClass=="PRIEST" and HealBot_EmergIncPriest==1 then ProcessUnit = 1;
          elseif  
             englishClass=="SHAMAN" and HealBot_EmergIncShaman==1 then ProcessUnit = 1;
          end

          if UnitInParty(unit) and HealBot_GroupHeals==1 then
            PossibleEmerg=0;
          end

          if ProcessUnit==1 and PossibleEmerg==1 then
            if HealBot_EmergRange==1 then
              if not HealBot_Action_UnitButtons[unit] and HealBot_MustHeal(unit) then
                if UnitHealth(unit)<UnitHealthMax(unit)*HealBot_EmergencyLevel then
                  if HealBot_Range_Check(unit, 40)==1 then
    				if HealBot_EmergencySort==1 then
                      order[unit] = UnitHealth(unit);
                    elseif HealBot_EmergencySort==2 then
                      order[unit] = UnitHealth(unit)/UnitHealthMax(unit);
                    else
                      order[unit] = HealBot_UnitTTL(unit);
                    end
                    table.insert(units,unit);
                  end
                end
              end
            else
              if not HealBot_Action_UnitButtons[unit] and HealBot_MustHeal(unit) then
                if UnitHealth(unit)<UnitHealthMax(unit)*HealBot_EmergencyLevel then
                  if HealBot_EmergencySort==1 then
                    order[unit] = UnitHealth(unit);
                  elseif HealBot_EmergencySort==2 then
                    order[unit] = UnitHealth(unit)/UnitHealthMax(unit);
                  else
                    order[unit] = HealBot_UnitTTL(unit);
                  end
                  table.insert(units,unit);
                end
              end
            end --<
          end
        end
      else
        for _,unit in ipairs(HealBot_Action_HealGroup) do
          if not HealBot_Action_UnitButtons[unit] and HealBot_MustHeal(unit) then
            if UnitHealth(unit)<UnitHealthMax(unit)*HealBot_EmergencyLevel then
              order[unit] = UnitHealth(unit);
              table.insert(units,unit);
            end
          end
        end
      end
    end
    table.sort(units,function (a,b)
      if order[a]<order[b] then return true end
      if order[a]>order[b] then return false end
      return a<b
    end)
    for j=1,40 do
      if not units[j] then break end
      i = i+1;
      HealBot_Action_SetHealButton(i,units[j]);
      if i==last then break end
    end
  end
  
  while i<last do
    i = i+1;
    HealBot_Action_SetHealButton(i,nil);
  end  

  OffsetY = 10;
  table.foreach(HealBot_Action_HealButtons, function (index,button)
    OffsetY = HealBot_Action_PositionButton(button,OffsetY);
  end);

  if HealBot_AbortButton==1 then
    HealBot_Action_AbortButton:Hide();
  else
    local bar = HealBot_Action_HealthBar(HealBot_Action_AbortButton);
    bar:SetMinMaxValues(0,100);
    bar:SetValue(100);
    bar:SetStatusBarColor(0.1,0.1,0.7,HealBot_BarAlpha);
    HealBot_Action_AbortButton:Show();
    OffsetY = OffsetY+20;
  end

  if HealBot_HideOptions==1 then
    HealBot_Action_OptionsButton:Hide();
  else
    if HealBot_AbortButton==1 then
       HealBot_Action_OptionsButton:SetPoint("BOTTOM","HealBot_Action","BOTTOM",0,10);
    else
       HealBot_Action_OptionsButton:SetPoint("BOTTOM","HealBot_Action","BOTTOM",0,35);
    end
    HealBot_Action_OptionsButton:Show();
    OffsetY = OffsetY+25;
  end

  HealBot_Action_SetHeight(OffsetY+10);
  HealBot_Action_RefreshButtons();
end

function HealBot_Action_Reset()
  HealBot_Action:ClearAllPoints();
  HealBot_Action:SetPoint("TOP","MinimapCluster","BOTTOM",7,10);
  HealBot_Action_HealTarget = {};
  HealBot_Action_PartyChanged();
end

local HealBot_Action_TooltipUnit = nil;
function HealBot_Action_RefreshTooltip(unit)
  if HealBot_ShowTooltip==0 then return end
  if not unit then unit = HealBot_Action_TooltipUnit end
  if not unit then return end;
  GameTooltip:ClearLines();
  local spell = HealBot_GetHealSpell(unit,HealBot_Action_SpellPattern());
  GameTooltip:SetText(spell or "none available");
  if spell and HealBot_Spells[spell] then
    if HealBot_Spells[spell].HealsDur>0 then

      GameTooltip:AddLine("Casting time is "..HealBot_Spells[spell].Cast.." sec.");

      if HealBot_Spells[spell].HealsMax>0 then
        local Heals = "Heals "
        if HealBot_Spells[spell].Shield then
          Heals = "Wards "
        end
        if HealBot_Spells[spell].HealsMin<HealBot_Spells[spell].HealsMax then
          GameTooltip:AddLine(Heals..format("%d", HealBot_Spells[spell].HealsMin + HealBot_Spells[spell].RealHealing) .." to "..format("%d",HealBot_Spells[spell].HealsMax + HealBot_Spells[spell].RealHealing)..".");
        else
          GameTooltip:AddLine(Heals..format("%d", HealBot_Spells[spell].HealsMax + HealBot_Spells[spell].RealHealing).." ");
        end
      end
      if HealBot_Spells[spell].HealsExt>0 then
        GameTooltip:AddLine("Heals "..HealBot_Spells[spell].HealsDur.." over "..HealBot_Spells[spell].Duration-HealBot_Spells[spell].Cast.." sec.");
      end

      GameTooltip:AddLine("Mana cost is "..HealBot_Spells[spell].Mana);
      if not HealBot_Spells[spell].Shield then
        GameTooltip:AddDoubleLine("--");
        GameTooltip:AddLine("Item bonuses +"..HealBot_GetBonus().." ");
        GameTooltip:AddLine("Actual bonus is +"..HealBot_Spells[spell].RealHealing.." ");
      end
    end
  end
  if HealBot_Debug then
    GameTooltip:AddLine(" ");
    GameTooltip:AddLine(UnitName(unit));
    GameTooltip:AddDoubleLine("Incoming DPS",HealBot_UnitStatus[unit].DPS,1,1,1);
    GameTooltip:AddDoubleLine("Seconds to hit",HealBot_UnitStatus[unit].TTH,1,1,1);
  end
  GameTooltip:Show();
end

function HealBot_Action_ShowTooltip(this)
  if HealBot_ShowTooltip==0 then return end
  if not this.unit then return end;
  if not this:IsEnabled() then return end;
  GameTooltip_SetDefaultAnchor(GameTooltip,this);
  HealBot_Action_TooltipUnit = this.unit;
  HealBot_Action_RefreshTooltip(this.unit);
end

function HealBot_Action_HideTooltip(this)
  if HealBot_ShowTooltip==0 then return end
  GameTooltip:Hide();
  HealBot_Action_TooltipUnit = nil;
end

function HealBot_Action_Refresh(unit)
  HealBot_Action_RefreshButtons(unit);
  if HealBot_AutoShow~=1 then return end 
  if (UnitIsDeadOrGhost("player")) then
    HideUIPanel(HealBot_Action);
  elseif (HealBot_Action_MustHealSome()) then
    ShowUIPanel(HealBot_Action);
  elseif HealBot_AbortButton==0 then
    ShowUIPanel(HealBot_Action);
  elseif (not HealBot_Action_ShouldHealSome()) then
    if HealBot_AbortButton==1 then
       HideUIPanel(HealBot_Action);
    end
  end
  HealBot_Action_RefreshTooltip(HealBot_Action_TooltipUnit);
end

function HealBot_Action_SpellPattern()
  local combos = HealBot_KeyCombo[UnitClass("player")]
  if not combos then return nil end
  local press = "Left"
  if IsControlKeyDown() then press = "Ctrl"..press end
  if IsShiftKeyDown() then press = "Shift"..press end
  return combos[press]
end

--------------------------------------------------------------------------------------------------
-- Widget_OnFoo functions
--------------------------------------------------------------------------------------------------

function HealBot_Action_HealUnit_OnLoad(this)
  this:RegisterForClicks("LeftButtonUp","RightButtonUp");
end

function HealBot_Action_HealUnit_OnEnter(this)
  HealBot_Action_ShowTooltip(this);
end

function HealBot_Action_HealUnit_OnLeave(this)
  HealBot_Action_HideTooltip(this);
end

function HealBot_Action_HealUnit_OnClick(this,button)
  if button=="RightButton" then
    if this.unit=="target" then
      local unit = HealBot_TargetName();
      if unit and table.getn(HealBot_Action_HealTarget)<5 then
        table.insert(HealBot_Action_HealTarget,unit)
      end
    else
      for i=1,table.getn(HealBot_Action_HealTarget) do
        if HealBot_Action_HealTarget[i]==this.unit then
          table.remove(HealBot_Action_HealTarget,i);
          break;
        end
      end
    end
    HealBot_Action_PartyChanged();
  else
    HealBot_HealUnit(this.unit,HealBot_Action_SpellPattern());
  end
end

function HealBot_Action_HealUnitCheck_OnClick(this)
  if not this.unit then return end
  if this:GetChecked() then
    table.insert(HealBot_Action_HealTarget,this.unit)
  else
    for i=1,table.getn(HealBot_Action_HealTarget) do
      if HealBot_Action_HealTarget[i]==this.unit then
        table.remove(HealBot_Action_HealTarget,i);
        break;
      end
    end
  end
  HealBot_Action_PartyChanged();
end

function HealBot_Action_OptionsButton_OnClick(this)
  HealBot_TogglePanel(HealBot_Options);
end

function HealBot_Action_AbortButton_OnClick(this)
  SpellStopCasting();
end

function HealBot_Action_IntegrationActive(type)
  return HealBot_Config["Integrate"..type]==1 and (IsAltKeyDown() or 0)==1-(HealBot_ToggleAltUse or 0);
end

local HealBot_CT_RA_CustomOnClickFunction_Old;
function HealBot_CT_RA_CustomOnClickFunction(button,unit)
  if HealBot_Action_IntegrationActive("CTRA") then
    HealBot_HealUnit(unit,HealBot_Action_SpellPattern())
    return true;
  end
  if (type(HealBot_CT_RA_CustomOnClickFunction_Old)=="function") then
    return HealBot_CT_RA_CustomOnClickFunction_Old(button,unit);
  end
  return false;
end

local HealBot_CT_RA_UpdateMTs_Old;
function HealBot_CT_RA_UpdateMTs()
  local value = HealBot_CT_RA_UpdateMTs_Old();
  if HealBot_IntegrateCTRA==1 then
    HealBot_Action_PartyChanged();
  end
  return value;
end

function HealBot_CT_RaidAssist()
  if (type(CT_RA_MemberFrame_OnClick)=="function") then
    HealBot_CT_RA_CustomOnClickFunction_Old = CT_RA_CustomOnClickFunction;
    CT_RA_CustomOnClickFunction = HealBot_CT_RA_CustomOnClickFunction;
  end
  if (type(CT_RA_UpdateMTs)=="function") then
    HealBot_CT_RA_UpdateMTs_Old = CT_RA_UpdateMTs;
    CT_RA_UpdateMTs = HealBot_CT_RA_UpdateMTs;
  end
end

--------------------------------------------------------------------------------------------------
-- Frame_OnFoo functions
--------------------------------------------------------------------------------------------------

function HealBot_Action_OnLoad(this)
  HealBot_CT_RaidAssist();
end

function HealBot_Action_OnShow(this)
  if HealBot_PanelSounds==1 then
    PlaySound("igAbilityOpen");
  end
  HealBot_ActionVisible = 1
end

function HealBot_Action_OnHide(this)
  HealBot_StopMoving(this);
  if HealBot_PanelSounds==1 then
    PlaySound("igAbilityClose");
  end
  HealBot_ActionVisible = 0
end

function HealBot_Action_OnMouseDown(this,button)
  if button~="RightButton" then
    if HealBot_ActionLocked==0 then
      HealBot_StartMoving(this);
    end
  end
end

function HealBot_Action_OnMouseUp(this,button)
  if button~="RightButton" then
    HealBot_StopMoving(this);
  else
    HealBot_Action_OptionsButton_OnClick();
  end
end

function HealBot_Action_OnClick(this,button)
--  HealBot_Action_AddDebug("OnClick("..button..")");
end

function HealBot_Action_OnDragStart(this,button)
  if HealBot_ActionLocked==0 then
    HealBot_StartMoving(this);
  end
end

function HealBot_Action_OnDragStop(this)
  HealBot_StopMoving(this);
end

-- http://www.flexbarforums.com/viewtopic.php?t=66
function HealBot_Action_OnKey(this,key,state)
  local command = GetBindingAction(key); 
  if command then 
    DEFAULT_CHAT_FRAME:AddMessage(key.." "..state.." "..(command or "nil"));
    keystate = state
    RunBinding(command,keystate)
  end 
  DEFAULT_CHAT_FRAME:AddMessage("HealBot_Action_OnKey - "..key);
  if key=="SHIFT" or key=="CTRL" or key=="ALT" then
    DEFAULT_CHAT_FRAME:AddMessage((IsShiftKeyDown() or 0).." "..(IsControlKeyDown() or 0).." "..(IsAltKeyDown() or 0));
    HealBot_Action_Refresh();
  end
end