
function HealBot_Options_AddDebug(msg)
  HealBot_AddDebug("Options: " .. msg);
end

function HealBot_Options_Pct_OnLoad(this,text)
  this.text = text;
  getglobal(this:GetName().."Text"):SetText(text);
  getglobal(this:GetName().."Low"):SetText("0%");
  getglobal(this:GetName().."High"):SetText("100%");
  this:SetMinMaxValues(0.00,1.00);
  this:SetValueStep(0.01);
end

function HealBot_Options_Pct_OnValueChanged(this)
  local pct = math.floor(this:GetValue()*100+0.5);
  getglobal(this:GetName().."Text"):SetText(this.text .. " (" .. pct .. "%)");
  return this:GetValue();
end


function HealBot_Options_ActionAlpha_OnValueChanged(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.ActionAlphaPvE = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_ActionAlpha = HealBot_Config.ActionAlphaPvE;
  else
    HealBot_Config.ActionAlphaPvP = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_ActionAlpha = HealBot_Config.ActionAlphaPvP;
  end
  HealBot_Action:SetBackdropColor(
    TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,
    TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,
    TOOLTIP_DEFAULT_BACKGROUND_COLOR.b, 
    HealBot_ActionAlpha*0.8);
  HealBot_Action:SetBackdropBorderColor(
    TOOLTIP_DEFAULT_COLOR.r,
    TOOLTIP_DEFAULT_COLOR.g,
    TOOLTIP_DEFAULT_COLOR.b, 
    (HealBot_ActionAlpha+0.2)/2);
end

function HealBot_Options_BarAlpha_OnValueChanged(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.BarAlphaPvE = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_BarAlpha = HealBot_Config.BarAlphaPvE;
  else
    HealBot_Config.BarAlphaPvP = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_BarAlpha = HealBot_Config.BarAlphaPvP;
  end
end


function HealBot_Options_HealthPct_OnValueChanged(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.HealthPctPvE = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_HealthPct = HealBot_Config.HealthPctPvE;
    if HealBot_AlertLevel>HealBot_HealthPct then
      HealBot_Options_AlertLevel:SetValue(HealBot_HealthPct);
    end
  else
    HealBot_Config.HealthPctPvP = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_HealthPct = HealBot_Config.HealthPctPvP;
    if HealBot_AlertLevel>HealBot_HealthPct then
      HealBot_Options_AlertLevel:SetValue(HealBot_HealthPct);
    end
  end
  HealBot_Action_Refresh();
end


function HealBot_Options_AlertLevel_OnValueChanged(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.AlertLevelPvE = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_AlertLevel=HealBot_Config.AlertLevelPvE;
    if HealBot_HealthPct<HealBot_AlertLevel then
      HealBot_Options_HealthPct:SetValue(HealBot_AlertLevel);
    end
    if HealBot_EmergencyLevel>HealBot_AlertLevel then
      HealBot_Options_EmergencyLevel:SetValue(HealBot_AlertLevel);
    end
  else
    HealBot_Config.AlertLevelPvP = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_AlertLevel=HealBot_Config.AlertLevelPvP;
    if HealBot_HealthPct<HealBot_AlertLevel then
      HealBot_Options_HealthPct:SetValue(HealBot_AlertLevel);
    end
    if HealBot_EmergencyLevel>HealBot_AlertLevel then
      HealBot_Options_EmergencyLevel:SetValue(HealBot_AlertLevel);
    end
  end
  HealBot_Action_Refresh();
end


function HealBot_Options_EmergencyLevel_OnValueChanged(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.EmergencyLevelPvE = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_EmergencyLevel=HealBot_Config.EmergencyLevelPvE;
    if HealBot_AlertLevel<HealBot_EmergencyLevel then
      HealBot_Options_AlertLevel:SetValue(HealBot_EmergencyLevel);
    end
  else
    HealBot_Config.EmergencyLevelPvP = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_EmergencyLevel=HealBot_Config.EmergencyLevelPvP;
    if HealBot_AlertLevel<HealBot_EmergencyLevel then
      HealBot_Options_AlertLevel:SetValue(HealBot_EmergencyLevel);
    end
  end
  HealBot_Action_Refresh();
end


function HealBot_Options_AutoShow_OnLoad(this)
  getglobal(this:GetName().."Text"):SetText(HEALBOT_OPTIONS_AUTOSHOW);
end

function HealBot_Options_AutoShow_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.AutoShowPvE = this:GetChecked() or 0;
    HealBot_AutoShow=HealBot_Config.AutoShowPvE;
  else
    HealBot_Config.AutoShowPvP = this:GetChecked() or 0;
    HealBot_AutoShow=HealBot_Config.AutoShowPvP;
  end
  HealBot_Action_Refresh();
end


function HealBot_Options_PanelSounds_OnLoad(this)
  getglobal(this:GetName().."Text"):SetText(HEALBOT_OPTIONS_PANELSOUNDS);
end

function HealBot_Options_PanelSounds_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.PanelSoundsPvE = this:GetChecked() or 0;
    HealBot_PanelSounds=HealBot_Config.PanelSoundsPvE;
  else
    HealBot_Config.PanelSoundsPvP = this:GetChecked() or 0;
    HealBot_PanelSounds=HealBot_Config.PanelSoundsPvP;
  end
end


function HealBot_Options_ActionLocked_OnLoad(this)
  getglobal(this:GetName().."Text"):SetText(HEALBOT_OPTIONS_ACTIONLOCKED);
end

function HealBot_Options_ActionLocked_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.ActionLockedPvE = this:GetChecked() or 0;
    HealBot_ActionLocked=HealBot_Config.ActionLockedPvE;
  else
    HealBot_Config.ActionLockedPvP = this:GetChecked() or 0;
    HealBot_ActionLocked=HealBot_Config.ActionLockedPvP;
  end
end


function HealBot_Options_GroupHeals_OnLoad(this,text)
  this.text = text
  getglobal(this:GetName().."Text"):SetText(this.text);
end


function HealBot_Options_GroupHeals_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.GroupHealsPvE = this:GetChecked() or 0;
    HealBot_GroupHeals=HealBot_Config.GroupHealsPvE;
  else
    HealBot_Config.GroupHealsPvP = this:GetChecked() or 0;
    HealBot_GroupHeals=HealBot_Config.GroupHealsPvP;
  end
  HealBot_RecalcParty();
end


function HealBot_Options_TankHeals_OnLoad(this,text)
  this.text = text
  getglobal(this:GetName().."Text"):SetText(this.text);
end

function HealBot_Options_TankHeals_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.TankHealsPvE = this:GetChecked() or 0;
    HealBot_TankHeals=HealBot_Config.TankHealsPvE;
  else
    HealBot_Config.TankHealsPvP = this:GetChecked() or 0;
    HealBot_TankHeals=HealBot_Config.TankHealsPvP;
  end
  HealBot_RecalcParty();
end


function HealBot_Options_TargetHeals_OnLoad(this,text)
  this.text = text
  getglobal(this:GetName().."Text"):SetText(this.text);
end

function HealBot_Options_TargetHeals_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.TargetHealsPvE = this:GetChecked() or 0;
    HealBot_TargetHeals=HealBot_Config.TargetHealsPvE;
  else
    HealBot_Config.TargetHealsPvP = this:GetChecked() or 0;
    HealBot_TargetHeals=HealBot_Config.TargetHealsPvP;
  end
  HealBot_RecalcParty();
end


function HealBot_Options_EmergencyHeals_OnLoad(this,text)
  this.text = text
  getglobal(this:GetName().."Text"):SetText(this.text);
end

function HealBot_Options_EmergencyHeals_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.EmergencyHealsPvE = this:GetChecked() or 0;
    HealBot_EmergencyHeals=HealBot_Config.EmergencyHealsPvE;
  else
    HealBot_Config.EmergencyHealsPvP = this:GetChecked() or 0;
    HealBot_EmergencyHeals=HealBot_Config.EmergencyHealsPvP;
  end
  HealBot_RecalcParty();
end


function HealBot_Options_HealingUsage_OnValueChanged(this_val)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.HealingUsagePvE = this_val;
    HealBot_HealingUsage=HealBot_Config.HealingUsagePvE;
  else
    HealBot_Config.HealingUsagePvP = this_val;
    HealBot_HealingUsage=HealBot_Config.HealingUsagePvP;
  end
end


function HealBot_Options_OverHeal_OnValueChanged(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.OverHealPvE = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_OverHeal=HealBot_Config.OverHealPvE;
  else
    HealBot_Config.OverHealPvP = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_OverHeal=HealBot_Config.OverHealPvP;
  end
end

function HealBot_Options_ManaReserve_OnValueChanged(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.ManaReservePvE = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_ManaReserve=HealBot_Config.ManaReservePvE;
  else
    HealBot_Config.ManaReservePvP = HealBot_Options_Pct_OnValueChanged(this);
    HealBot_ManaReserve=HealBot_Config.ManaReservePvP;
  end
end

function HealBot_Options_AlertSeconds_OnLoad(this)
  getglobal(this:GetName().."Text"):SetText(HEALBOT_OPTIONS_ALERTSECONDS);
  getglobal(this:GetName().."Low"):SetText("0 sec");
  getglobal(this:GetName().."High"):SetText("60 sec");
  this:SetMinMaxValues(0.0,60.0);
  this:SetValueStep(1.0);
end

function HealBot_Options_AlertSeconds_OnValueChanged(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.AlertSecondsPvE = this:GetValue();
    HealBot_AlertSeconds=HealBot_Config.AlertSecondsPvE;
  else
    HealBot_Config.AlertSecondsPvP = this:GetValue();
    HealBot_AlertSeconds=HealBot_Config.AlertSecondsPvP;
  end
  getglobal(this:GetName().."Text"):SetText(HEALBOT_OPTIONS_ALERTSECONDS .. " (" .. HealBot_AlertSeconds .. " sec)");
  HealBot_Action_RefreshButtons();
end


function HealBot_Options_UseHealing_OnLoad(this,text)
  this.text = text;
  getglobal(this:GetName().."Text"):SetText(this.text);
end

function HealBot_Options_UseHealing_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.UseHealingPvE[this.text] = this:GetChecked() or 0;
    HealBot_UseHealing[this.text]=HealBot_Config.UseHealingPvE[this.text];
  else
    HealBot_Config.UseHealingPvP[this.text] = this:GetChecked() or 0;
    HealBot_UseHealing[this.text]=HealBot_Config.UseHealingPvP[this.text];
  end
--  HealBot_AddDebug("UseHealing[" .. this.text .. "] = " .. HealBot_Config.UseHealing[this.text]);
  HealBot_RecalcSpells();
end

function HealBot_Options_EFClass_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_EFClass_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    if HealBot_EmergencyFClass==1 then
      HealBot_Config.EmergIncMeleePvE[HEALBOT_DRUID] = HealBot_Options_EFClassDruid:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_DRUID] = HealBot_Config.EmergIncMeleePvE[HEALBOT_DRUID];
      HealBot_Config.EmergIncMeleePvE[HEALBOT_HUNTER] = HealBot_Options_EFClassHunter:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_HUNTER] = HealBot_Config.EmergIncMeleePvE[HEALBOT_HUNTER];
      HealBot_Config.EmergIncMeleePvE[HEALBOT_MAGE] = HealBot_Options_EFClassMage:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_MAGE] = HealBot_Config.EmergIncMeleePvE[HEALBOT_MAGE];
      HealBot_Config.EmergIncMeleePvE[HEALBOT_PALADIN] = HealBot_Options_EFClassPaladin:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_PALADIN] = HealBot_Config.EmergIncMeleePvE[HEALBOT_PALADIN];
      HealBot_Config.EmergIncMeleePvE[HEALBOT_PRIEST] = HealBot_Options_EFClassPriest:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_PRIEST] = HealBot_Config.EmergIncMeleePvE[HEALBOT_PRIEST];
      HealBot_Config.EmergIncMeleePvE[HEALBOT_ROGUE] = HealBot_Options_EFClassRogue:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_ROGUE] = HealBot_Config.EmergIncMeleePvE[HEALBOT_ROGUE];
      HealBot_Config.EmergIncMeleePvE[HEALBOT_SHAMAN] = HealBot_Options_EFClassShaman:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_SHAMAN] = HealBot_Config.EmergIncMeleePvE[HEALBOT_SHAMAN];
      HealBot_Config.EmergIncMeleePvE[HEALBOT_WARLOCK] = HealBot_Options_EFClassWarlock:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_WARLOCK] = HealBot_Config.EmergIncMeleePvE[HEALBOT_WARLOCK];
      HealBot_Config.EmergIncMeleePvE[HEALBOT_WARRIOR] = HealBot_Options_EFClassWarrior:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_WARRIOR] = HealBot_Config.EmergIncMeleePvE[HEALBOT_WARRIOR];
    elseif HealBot_EmergencyFClass==2 then
      HealBot_Config.EmergIncRangePvE[HEALBOT_DRUID] = HealBot_Options_EFClassDruid:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_DRUID] = HealBot_Config.EmergIncRangePvE[HEALBOT_DRUID];
      HealBot_Config.EmergIncRangePvE[HEALBOT_HUNTER] = HealBot_Options_EFClassHunter:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_HUNTER] = HealBot_Config.EmergIncRangePvE[HEALBOT_HUNTER];
      HealBot_Config.EmergIncRangePvE[HEALBOT_MAGE] = HealBot_Options_EFClassMage:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_MAGE] = HealBot_Config.EmergIncRangePvE[HEALBOT_MAGE];
      HealBot_Config.EmergIncRangePvE[HEALBOT_PALADIN] = HealBot_Options_EFClassPaladin:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_PALADIN] = HealBot_Config.EmergIncRangePvE[HEALBOT_PALADIN];
      HealBot_Config.EmergIncRangePvE[HEALBOT_PRIEST] = HealBot_Options_EFClassPriest:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_PRIEST] = HealBot_Config.EmergIncRangePvE[HEALBOT_PRIEST];
      HealBot_Config.EmergIncRangePvE[HEALBOT_ROGUE] = HealBot_Options_EFClassRogue:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_ROGUE] = HealBot_Config.EmergIncRangePvE[HEALBOT_ROGUE];
      HealBot_Config.EmergIncRangePvE[HEALBOT_SHAMAN] = HealBot_Options_EFClassShaman:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_SHAMAN] = HealBot_Config.EmergIncRangePvE[HEALBOT_SHAMAN];
      HealBot_Config.EmergIncRangePvE[HEALBOT_WARLOCK] = HealBot_Options_EFClassWarlock:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_WARLOCK] = HealBot_Config.EmergIncRangePvE[HEALBOT_WARLOCK];
      HealBot_Config.EmergIncRangePvE[HEALBOT_WARRIOR] = HealBot_Options_EFClassWarrior:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_WARRIOR] = HealBot_Config.EmergIncRangePvE[HEALBOT_WARRIOR];
    elseif HealBot_EmergencyFClass==3 then
      HealBot_Config.EmergIncHealersPvE[HEALBOT_DRUID] = HealBot_Options_EFClassDruid:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_DRUID] = HealBot_Config.EmergIncHealersPvE[HEALBOT_DRUID];
      HealBot_Config.EmergIncHealersPvE[HEALBOT_HUNTER] = HealBot_Options_EFClassHunter:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_HUNTER] = HealBot_Config.EmergIncHealersPvE[HEALBOT_HUNTER];
      HealBot_Config.EmergIncHealersPvE[HEALBOT_MAGE] = HealBot_Options_EFClassMage:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_MAGE] = HealBot_Config.EmergIncHealersPvE[HEALBOT_MAGE];
      HealBot_Config.EmergIncHealersPvE[HEALBOT_PALADIN] = HealBot_Options_EFClassPaladin:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_PALADIN] = HealBot_Config.EmergIncHealersPvE[HEALBOT_PALADIN];
      HealBot_Config.EmergIncHealersPvE[HEALBOT_PRIEST] = HealBot_Options_EFClassPriest:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_PRIEST] = HealBot_Config.EmergIncHealersPvE[HEALBOT_PRIEST];
      HealBot_Config.EmergIncHealersPvE[HEALBOT_ROGUE] = HealBot_Options_EFClassRogue:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_ROGUE] = HealBot_Config.EmergIncHealersPvE[HEALBOT_ROGUE];
      HealBot_Config.EmergIncHealersPvE[HEALBOT_SHAMAN] = HealBot_Options_EFClassShaman:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_SHAMAN] = HealBot_Config.EmergIncHealersPvE[HEALBOT_SHAMAN];
      HealBot_Config.EmergIncHealersPvE[HEALBOT_WARLOCK] = HealBot_Options_EFClassWarlock:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_WARLOCK] = HealBot_Config.EmergIncHealersPvE[HEALBOT_WARLOCK];
      HealBot_Config.EmergIncHealersPvE[HEALBOT_WARRIOR] = HealBot_Options_EFClassWarrior:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_WARRIOR] = HealBot_Config.EmergIncHealersPvE[HEALBOT_WARRIOR];
    elseif HealBot_EmergencyFClass==4 then
      HealBot_Config.EmergIncCustomPvE[HEALBOT_DRUID] = HealBot_Options_EFClassDruid:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_DRUID] = HealBot_Config.EmergIncCustomPvE[HEALBOT_DRUID];
      HealBot_Config.EmergIncCustomPvE[HEALBOT_HUNTER] = HealBot_Options_EFClassHunter:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_HUNTER] = HealBot_Config.EmergIncCustomPvE[HEALBOT_HUNTER];
      HealBot_Config.EmergIncCustomPvE[HEALBOT_MAGE] = HealBot_Options_EFClassMage:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_MAGE] = HealBot_Config.EmergIncCustomPvE[HEALBOT_MAGE];
      HealBot_Config.EmergIncCustomPvE[HEALBOT_PALADIN] = HealBot_Options_EFClassPaladin:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_PALADIN] = HealBot_Config.EmergIncCustomPvE[HEALBOT_PALADIN];
      HealBot_Config.EmergIncCustomPvE[HEALBOT_PRIEST] = HealBot_Options_EFClassPriest:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_PRIEST] = HealBot_Config.EmergIncCustomPvE[HEALBOT_PRIEST];
      HealBot_Config.EmergIncCustomPvE[HEALBOT_ROGUE] = HealBot_Options_EFClassRogue:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_ROGUE] = HealBot_Config.EmergIncCustomPvE[HEALBOT_ROGUE];
      HealBot_Config.EmergIncCustomPvE[HEALBOT_SHAMAN] = HealBot_Options_EFClassShaman:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_SHAMAN] = HealBot_Config.EmergIncCustomPvE[HEALBOT_SHAMAN];
      HealBot_Config.EmergIncCustomPvE[HEALBOT_WARLOCK] = HealBot_Options_EFClassWarlock:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_WARLOCK] = HealBot_Config.EmergIncCustomPvE[HEALBOT_WARLOCK];
      HealBot_Config.EmergIncCustomPvE[HEALBOT_WARRIOR] = HealBot_Options_EFClassWarrior:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_WARRIOR] = HealBot_Config.EmergIncCustomPvE[HEALBOT_WARRIOR];
    end
  else
    if HealBot_EmergencyFClass==1 then
      HealBot_Config.EmergIncMeleePvP[HEALBOT_DRUID] = HealBot_Options_EFClassDruid:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_DRUID] = HealBot_Config.EmergIncMeleePvP[HEALBOT_DRUID];
      HealBot_Config.EmergIncMeleePvP[HEALBOT_HUNTER] = HealBot_Options_EFClassHunter:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_HUNTER] = HealBot_Config.EmergIncMeleePvP[HEALBOT_HUNTER];
      HealBot_Config.EmergIncMeleePvP[HEALBOT_MAGE] = HealBot_Options_EFClassMage:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_MAGE] = HealBot_Config.EmergIncMeleePvP[HEALBOT_MAGE];
      HealBot_Config.EmergIncMeleePvP[HEALBOT_PALADIN] = HealBot_Options_EFClassPaladin:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_PALADIN] = HealBot_Config.EmergIncMeleePvP[HEALBOT_PALADIN];
      HealBot_Config.EmergIncMeleePvP[HEALBOT_PRIEST] = HealBot_Options_EFClassPriest:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_PRIEST] = HealBot_Config.EmergIncMeleePvP[HEALBOT_PRIEST];
      HealBot_Config.EmergIncMeleePvP[HEALBOT_ROGUE] = HealBot_Options_EFClassRogue:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_ROGUE] = HealBot_Config.EmergIncMeleePvP[HEALBOT_ROGUE];
      HealBot_Config.EmergIncMeleePvP[HEALBOT_SHAMAN] = HealBot_Options_EFClassShaman:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_SHAMAN] = HealBot_Config.EmergIncMeleePvP[HEALBOT_SHAMAN];
      HealBot_Config.EmergIncMeleePvP[HEALBOT_WARLOCK] = HealBot_Options_EFClassWarlock:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_WARLOCK] = HealBot_Config.EmergIncMeleePvP[HEALBOT_WARLOCK];
      HealBot_Config.EmergIncMeleePvP[HEALBOT_WARRIOR] = HealBot_Options_EFClassWarrior:GetChecked() or 0;
      HealBot_EmergIncMelee[HEALBOT_WARRIOR] = HealBot_Config.EmergIncMeleePvP[HEALBOT_WARRIOR];
    elseif HealBot_EmergencyFClass==2 then
      HealBot_Config.EmergIncRangePvP[HEALBOT_DRUID] = HealBot_Options_EFClassDruid:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_DRUID] = HealBot_Config.EmergIncRangePvP[HEALBOT_DRUID];
      HealBot_Config.EmergIncRangePvP[HEALBOT_HUNTER] = HealBot_Options_EFClassHunter:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_HUNTER] = HealBot_Config.EmergIncRangePvP[HEALBOT_HUNTER];
      HealBot_Config.EmergIncRangePvP[HEALBOT_MAGE] = HealBot_Options_EFClassMage:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_MAGE] = HealBot_Config.EmergIncRangePvP[HEALBOT_MAGE];
      HealBot_Config.EmergIncRangePvP[HEALBOT_PALADIN] = HealBot_Options_EFClassPaladin:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_PALADIN] = HealBot_Config.EmergIncRangePvP[HEALBOT_PALADIN];
      HealBot_Config.EmergIncRangePvP[HEALBOT_PRIEST] = HealBot_Options_EFClassPriest:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_PRIEST] = HealBot_Config.EmergIncRangePvP[HEALBOT_PRIEST];
      HealBot_Config.EmergIncRangePvP[HEALBOT_ROGUE] = HealBot_Options_EFClassRogue:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_ROGUE] = HealBot_Config.EmergIncRangePvP[HEALBOT_ROGUE];
      HealBot_Config.EmergIncRangePvP[HEALBOT_SHAMAN] = HealBot_Options_EFClassShaman:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_SHAMAN] = HealBot_Config.EmergIncRangePvP[HEALBOT_SHAMAN];
      HealBot_Config.EmergIncRangePvP[HEALBOT_WARLOCK] = HealBot_Options_EFClassWarlock:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_WARLOCK] = HealBot_Config.EmergIncRangePvP[HEALBOT_WARLOCK];
      HealBot_Config.EmergIncRangePvP[HEALBOT_WARRIOR] = HealBot_Options_EFClassWarrior:GetChecked() or 0;
      HealBot_EmergIncRange[HEALBOT_WARRIOR] = HealBot_Config.EmergIncRangePvP[HEALBOT_WARRIOR];
    elseif HealBot_EmergencyFClass==3 then
      HealBot_Config.EmergIncHealersPvP[HEALBOT_DRUID] = HealBot_Options_EFClassDruid:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_DRUID] = HealBot_Config.EmergIncHealersPvP[HEALBOT_DRUID];
      HealBot_Config.EmergIncHealersPvP[HEALBOT_HUNTER] = HealBot_Options_EFClassHunter:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_HUNTER] = HealBot_Config.EmergIncHealersPvP[HEALBOT_HUNTER];
      HealBot_Config.EmergIncHealersPvP[HEALBOT_MAGE] = HealBot_Options_EFClassMage:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_MAGE] = HealBot_Config.EmergIncHealersPvP[HEALBOT_MAGE];
      HealBot_Config.EmergIncHealersPvP[HEALBOT_PALADIN] = HealBot_Options_EFClassPaladin:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_PALADIN] = HealBot_Config.EmergIncHealersPvP[HEALBOT_PALADIN];
      HealBot_Config.EmergIncHealersPvP[HEALBOT_PRIEST] = HealBot_Options_EFClassPriest:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_PRIEST] = HealBot_Config.EmergIncHealersPvP[HEALBOT_PRIEST];
      HealBot_Config.EmergIncHealersPvP[HEALBOT_ROGUE] = HealBot_Options_EFClassRogue:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_ROGUE] = HealBot_Config.EmergIncHealersPvP[HEALBOT_ROGUE];
      HealBot_Config.EmergIncHealersPvP[HEALBOT_SHAMAN] = HealBot_Options_EFClassShaman:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_SHAMAN] = HealBot_Config.EmergIncHealersPvP[HEALBOT_SHAMAN];
      HealBot_Config.EmergIncHealersPvP[HEALBOT_WARLOCK] = HealBot_Options_EFClassWarlock:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_WARLOCK] = HealBot_Config.EmergIncHealersPvP[HEALBOT_WARLOCK];
      HealBot_Config.EmergIncHealersPvP[HEALBOT_WARRIOR] = HealBot_Options_EFClassWarrior:GetChecked() or 0;
      HealBot_EmergIncHealers[HEALBOT_WARRIOR] = HealBot_Config.EmergIncHealersPvP[HEALBOT_WARRIOR];
    elseif HealBot_EmergencyFClass==4 then
      HealBot_Config.EmergIncCustomPvP[HEALBOT_DRUID] = HealBot_Options_EFClassDruid:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_DRUID] = HealBot_Config.EmergIncCustomPvP[HEALBOT_DRUID];
      HealBot_Config.EmergIncCustomPvP[HEALBOT_HUNTER] = HealBot_Options_EFClassHunter:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_HUNTER] = HealBot_Config.EmergIncCustomPvP[HEALBOT_HUNTER];
      HealBot_Config.EmergIncCustomPvP[HEALBOT_MAGE] = HealBot_Options_EFClassMage:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_MAGE] = HealBot_Config.EmergIncCustomPvP[HEALBOT_MAGE];
      HealBot_Config.EmergIncCustomPvP[HEALBOT_PALADIN] = HealBot_Options_EFClassPaladin:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_PALADIN] = HealBot_Config.EmergIncCustomPvP[HEALBOT_PALADIN];
      HealBot_Config.EmergIncCustomPvP[HEALBOT_PRIEST] = HealBot_Options_EFClassPriest:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_PRIEST] = HealBot_Config.EmergIncCustomPvP[HEALBOT_PRIEST];
      HealBot_Config.EmergIncCustomPvP[HEALBOT_ROGUE] = HealBot_Options_EFClassRogue:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_ROGUE] = HealBot_Config.EmergIncCustomPvP[HEALBOT_ROGUE];
      HealBot_Config.EmergIncCustomPvP[HEALBOT_SHAMAN] = HealBot_Options_EFClassShaman:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_SHAMAN] = HealBot_Config.EmergIncCustomPvP[HEALBOT_SHAMAN];
      HealBot_Config.EmergIncCustomPvP[HEALBOT_WARLOCK] = HealBot_Options_EFClassWarlock:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_WARLOCK] = HealBot_Config.EmergIncCustomPvP[HEALBOT_WARLOCK];
      HealBot_Config.EmergIncCustomPvP[HEALBOT_WARRIOR] = HealBot_Options_EFClassWarrior:GetChecked() or 0;
      HealBot_EmergIncCustom[HEALBOT_WARRIOR] = HealBot_Config.EmergIncCustomPvP[HEALBOT_WARRIOR];
    end
  end
  if HealBot_EmergIncMonitor>10 then
     HealBot_Action_PartyChanged();
  end
end


function HealBot_Options_CastNotify_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_CastNotify_OnClick(this,id)
  if HealBot_Config.HealBot_Profile==1 then
    if HealBot_Config.CastNotifyPvE>0 then
      getglobal("HealBot_Options_CastNotify"..HealBot_Config.CastNotifyPvE):SetChecked(nil);
    end
    HealBot_Config.CastNotifyPvE = id;
    if HealBot_Config.CastNotifyPvE>0 then
      getglobal("HealBot_Options_CastNotify"..HealBot_Config.CastNotifyPvE):SetChecked(1);
    end
    HealBot_CastNotify = HealBot_Config.CastNotifyPvE;
  else
    if HealBot_Config.CastNotifyPvP>0 then
      getglobal("HealBot_Options_CastNotify"..HealBot_Config.CastNotifyPvP):SetChecked(nil);
    end
    HealBot_Config.CastNotifyPvP = id;
    if HealBot_Config.CastNotifyPvP>0 then
      getglobal("HealBot_Options_CastNotify"..HealBot_Config.CastNotifyPvP):SetChecked(1);
    end
    HealBot_CastNotify = HealBot_Config.CastNotifyPvP;
  end
end


function HealBot_Options_HideOptions_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_HideOptions_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.HideOptionsPvE = this:GetChecked() or 0;
    HealBot_HideOptions=HealBot_Config.HideOptionsPvE;
  else
    HealBot_Config.HideOptionsPvP = this:GetChecked() or 0;
    HealBot_HideOptions=HealBot_Config.HideOptionsPvP;
  end
  HealBot_Action_PartyChanged();
end


function HealBot_Options_ShowTooltip_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_ShowTooltip_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.ShowTooltipPvE = this:GetChecked() or 0;
    HealBot_ShowTooltip=HealBot_Config.ShowTooltipPvE;
  else
    HealBot_Config.ShowTooltipPvP = this:GetChecked() or 0;
    HealBot_ShowTooltip=HealBot_Config.ShowTooltipPvP;
  end

--  HealBot_Action_PartyChanged();
end


function HealBot_Options_GrowUpwards_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_GrowUpwards_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.GrowUpwardsPvE = this:GetChecked() or 0;
    HealBot_GrowUpwards=HealBot_Config.GrowUpwardsPvE;
  else
    HealBot_Config.GrowUpwardsPvP = this:GetChecked() or 0;
    HealBot_GrowUpwards=HealBot_Config.GrowUpwardsPvP;
  end

  HealBot_Action_PartyChanged();
end


function HealBot_Options_QualityRange_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_QualityRange_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.QualityRangePvE = this:GetChecked() or 0;
    HealBot_QualityRange=HealBot_Config.QualityRangePvE;
  else
    HealBot_Config.QualityRangePvP = this:GetChecked() or 0;
    HealBot_QualityRange=HealBot_Config.QualityRangePvP;
  end

--  HealBot_Action_PartyChanged();
end

function HealBot_Options_EmergRange_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_EmergRange_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.EmergRangePvE = this:GetChecked() or 0;
    HealBot_EmergRange=HealBot_Config.EmergRangePvE;
  else
    HealBot_Config.EmergRangePvP = this:GetChecked() or 0;
    HealBot_EmergRange=HealBot_Config.EmergRangePvP;
  end

--  HealBot_Action_PartyChanged();
end


function HealBot_Options_IntegrateCTRA_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_IntegrateCTRA_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.IntegrateCTRAPvE = this:GetChecked() or 0;
    HealBot_IntegrateCTRA=HealBot_Config.IntegrateCTRAPvE;
  else
    HealBot_Config.IntegrateCTRAPvP = this:GetChecked() or 0;
    HealBot_IntegrateCTRA=HealBot_Config.IntegrateCTRAPvP;
  end

--  HealBot_Action_PartyChanged();
end


function HealBot_Options_ToggleAltUse_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_ToggleAltUse_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.ToggleAltUsePvE = this:GetChecked() or 0;
    HealBot_ToggleAltUse = HealBot_Config.ToggleAltUsePvE;
  else
    HealBot_Config.ToggleAltUsePvP = this:GetChecked() or 0;
    HealBot_ToggleAltUse = HealBot_Config.ToggleAltUsePvP;
  end

--  HealBot_Action_PartyChanged();
end


function HealBot_Options_ProtectPvP_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_ProtectPvP_OnClick(this)
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.ProtectPvPPvE = this:GetChecked() or 0;
    HealBot_ProtectPvP=HealBot_Config.ProtectPvPPvE;
  else
    HealBot_Config.ProtectPvPPvP = this:GetChecked() or 0;
    HealBot_ProtectPvP=HealBot_Config.ProtectPvPPvP;
  end

  HealBot_Action_Refresh();
end

--------------------------------------------------------------------------------

local HealBot_Options_EmergencySort_List = {
  HEALBOT_OPTIONS_SORTHEALTH,
  HEALBOT_OPTIONS_SORTPERCENT,
  HEALBOT_OPTIONS_SORTSURVIVAL,
}

function HealBot_Options_EmergencySort_DropDown()
  for i=1, getn(HealBot_Options_EmergencySort_List), 1 do
    local info = {};
    info.text = HealBot_Options_EmergencySort_List[i];
    info.func = HealBot_Options_EmergencySort_OnSelect;
    UIDropDownMenu_AddButton(info);
  end
end

function HealBot_Options_EmergencySort_Initialize()
  UIDropDownMenu_Initialize(HealBot_Options_EmergencySort,HealBot_Options_EmergencySort_DropDown)
end

function HealBot_Options_EmergencySort_Refresh(onselect)
  if not HealBot_EmergencySort then return end
  if not onselect then HealBot_Options_EmergencySort_Initialize() end  -- or wrong menu may be used !
  UIDropDownMenu_SetSelectedID(HealBot_Options_EmergencySort,HealBot_EmergencySort)
end

function HealBot_Options_EmergencySort_OnLoad(this)
  HealBot_Options_EmergencySort_Initialize()
  UIDropDownMenu_SetWidth(100)
end

function HealBot_Options_EmergencySort_OnSelect()
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.EmergencySortPvE = this:GetID()
    HealBot_EmergencySort=HealBot_Config.EmergencySortPvE;
  else
    HealBot_Config.EmergencySortPvP = this:GetID()
    HealBot_EmergencySort=HealBot_Config.EmergencySortPvP;
  end
  HealBot_Options_EmergencySort_Refresh(true)
  HealBot_Action_PartyChanged()
end

--------------------------------------------------------------------------------

local HealBot_Options_EmergencyFClass_List = {
  HEALBOT_CLASSES_MELEE,
  HEALBOT_CLASSES_RANGES,
  HEALBOT_CLASSES_HEALERS,
  HEALBOT_CLASSES_CUSTOM,
}

function HealBot_Options_EmergencyFClass_DropDown()
  for i=1, getn(HealBot_Options_EmergencyFClass_List), 1 do
    local info = {};
    info.text = HealBot_Options_EmergencyFClass_List[i];
    info.func = HealBot_Options_EmergencyFClass_OnSelect;
    UIDropDownMenu_AddButton(info);
  end
end

function HealBot_Options_EmergencyFClass_Initialize()
  UIDropDownMenu_Initialize(HealBot_Options_EmergencyFClass,HealBot_Options_EmergencyFClass_DropDown)
end

function HealBot_Options_EmergencyFClass_Refresh(onselect)
  if not HealBot_EmergencyFClass then return end
  if not onselect then HealBot_Options_EmergencyFClass_Initialize() end  -- or wrong menu may be used !
  UIDropDownMenu_SetSelectedID(HealBot_Options_EmergencyFClass,HealBot_EmergencyFClass)
end

function HealBot_Options_EmergencyFClass_OnLoad(this)
  HealBot_Options_EmergencyFClass_Initialize()
  UIDropDownMenu_SetWidth(100)
end

function HealBot_Options_EmergencyFClass_OnSelect()
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.EmergencyFClassPvE = this:GetID()
    HealBot_EmergencyFClass=HealBot_Config.EmergencyFClassPvE;
  else
    HealBot_Config.EmergencyFClassPvP = this:GetID()
    HealBot_EmergencyFClass=HealBot_Config.EmergencyFClassPvP;
  end
  HealBot_Options_EmergencyFClass_Refresh(true)
  HealBot_Options_EFClass_Reset()
end

function HealBot_Options_EFClass_Reset()
  if HealBot_EmergencyFClass==1 then
    HealBot_Options_EFClassDruid:SetChecked(HealBot_EmergIncMelee[HEALBOT_DRUID]);
    HealBot_Options_EFClassHunter:SetChecked(HealBot_EmergIncMelee[HEALBOT_HUNTER]);
    HealBot_Options_EFClassMage:SetChecked(HealBot_EmergIncMelee[HEALBOT_MAGE]);
    HealBot_Options_EFClassPaladin:SetChecked(HealBot_EmergIncMelee[HEALBOT_PALADIN]);
    HealBot_Options_EFClassPriest:SetChecked(HealBot_EmergIncMelee[HEALBOT_PRIEST]);
    HealBot_Options_EFClassRogue:SetChecked(HealBot_EmergIncMelee[HEALBOT_ROGUE]);
    HealBot_Options_EFClassShaman:SetChecked(HealBot_EmergIncMelee[HEALBOT_SHAMAN]);
    HealBot_Options_EFClassWarlock:SetChecked(HealBot_EmergIncMelee[HEALBOT_WARLOCK]);
    HealBot_Options_EFClassWarrior:SetChecked(HealBot_EmergIncMelee[HEALBOT_WARRIOR]);
  elseif HealBot_EmergencyFClass==2 then
    HealBot_Options_EFClassDruid:SetChecked(HealBot_EmergIncRange[HEALBOT_DRUID]);
    HealBot_Options_EFClassHunter:SetChecked(HealBot_EmergIncRange[HEALBOT_HUNTER]);
    HealBot_Options_EFClassMage:SetChecked(HealBot_EmergIncRange[HEALBOT_MAGE]);
    HealBot_Options_EFClassPaladin:SetChecked(HealBot_EmergIncRange[HEALBOT_PALADIN]);
    HealBot_Options_EFClassPriest:SetChecked(HealBot_EmergIncRange[HEALBOT_PRIEST]);
    HealBot_Options_EFClassRogue:SetChecked(HealBot_EmergIncRange[HEALBOT_ROGUE]);
    HealBot_Options_EFClassShaman:SetChecked(HealBot_EmergIncRange[HEALBOT_SHAMAN]);
    HealBot_Options_EFClassWarlock:SetChecked(HealBot_EmergIncRange[HEALBOT_WARLOCK]);
    HealBot_Options_EFClassWarrior:SetChecked(HealBot_EmergIncRange[HEALBOT_WARRIOR]);
  elseif HealBot_EmergencyFClass==3 then
    HealBot_Options_EFClassDruid:SetChecked(HealBot_EmergIncHealers[HEALBOT_DRUID]);
    HealBot_Options_EFClassHunter:SetChecked(HealBot_EmergIncHealers[HEALBOT_HUNTER]);
    HealBot_Options_EFClassMage:SetChecked(HealBot_EmergIncHealers[HEALBOT_MAGE]);
    HealBot_Options_EFClassPaladin:SetChecked(HealBot_EmergIncHealers[HEALBOT_PALADIN]);
    HealBot_Options_EFClassPriest:SetChecked(HealBot_EmergIncHealers[HEALBOT_PRIEST]);
    HealBot_Options_EFClassRogue:SetChecked(HealBot_EmergIncHealers[HEALBOT_ROGUE]);
    HealBot_Options_EFClassShaman:SetChecked(HealBot_EmergIncHealers[HEALBOT_SHAMAN]);
    HealBot_Options_EFClassWarlock:SetChecked(HealBot_EmergIncHealers[HEALBOT_WARLOCK]);
    HealBot_Options_EFClassWarrior:SetChecked(HealBot_EmergIncHealers[HEALBOT_WARRIOR]);
  elseif HealBot_EmergencyFClass==4 then
    HealBot_Options_EFClassDruid:SetChecked(HealBot_EmergIncCustom[HEALBOT_DRUID]);
    HealBot_Options_EFClassHunter:SetChecked(HealBot_EmergIncCustom[HEALBOT_HUNTER]);
    HealBot_Options_EFClassMage:SetChecked(HealBot_EmergIncCustom[HEALBOT_MAGE]);
    HealBot_Options_EFClassPaladin:SetChecked(HealBot_EmergIncCustom[HEALBOT_PALADIN]);
    HealBot_Options_EFClassPriest:SetChecked(HealBot_EmergIncCustom[HEALBOT_PRIEST]);
    HealBot_Options_EFClassRogue:SetChecked(HealBot_EmergIncCustom[HEALBOT_ROGUE]);
    HealBot_Options_EFClassShaman:SetChecked(HealBot_EmergIncCustom[HEALBOT_SHAMAN]);
    HealBot_Options_EFClassWarlock:SetChecked(HealBot_EmergIncCustom[HEALBOT_WARLOCK]);
    HealBot_Options_EFClassWarrior:SetChecked(HealBot_EmergIncCustom[HEALBOT_WARRIOR]);
  end
end

function HealBot_Options_EFClass_SetPvE()
  HealBot_EmergIncMelee[HEALBOT_DRUID]=HealBot_Config.EmergIncMeleePvE[HEALBOT_DRUID];
  HealBot_EmergIncMelee[HEALBOT_HUNTER]=HealBot_Config.EmergIncMeleePvE[HEALBOT_HUNTER];
  HealBot_EmergIncMelee[HEALBOT_MAGE]=HealBot_Config.EmergIncMeleePvE[HEALBOT_MAGE];
  HealBot_EmergIncMelee[HEALBOT_PALADIN]=HealBot_Config.EmergIncMeleePvE[HEALBOT_PALADIN];
  HealBot_EmergIncMelee[HEALBOT_PRIEST]=HealBot_Config.EmergIncMeleePvE[HEALBOT_PRIEST];
  HealBot_EmergIncMelee[HEALBOT_ROGUE]=HealBot_Config.EmergIncMeleePvE[HEALBOT_ROGUE];
  HealBot_EmergIncMelee[HEALBOT_SHAMAN]=HealBot_Config.EmergIncMeleePvE[HEALBOT_SHAMAN];
  HealBot_EmergIncMelee[HEALBOT_WARLOCK]=HealBot_Config.EmergIncMeleePvE[HEALBOT_WARLOCK];
  HealBot_EmergIncMelee[HEALBOT_WARRIOR]=HealBot_Config.EmergIncMeleePvE[HEALBOT_WARRIOR];
  HealBot_EmergIncRange[HEALBOT_DRUID]=HealBot_Config.EmergIncRangePvE[HEALBOT_DRUID];
  HealBot_EmergIncRange[HEALBOT_HUNTER]=HealBot_Config.EmergIncRangePvE[HEALBOT_HUNTER];
  HealBot_EmergIncRange[HEALBOT_MAGE]=HealBot_Config.EmergIncRangePvE[HEALBOT_MAGE];
  HealBot_EmergIncRange[HEALBOT_PALADIN]=HealBot_Config.EmergIncRangePvE[HEALBOT_PALADIN];
  HealBot_EmergIncRange[HEALBOT_PRIEST]=HealBot_Config.EmergIncRangePvE[HEALBOT_PRIEST];
  HealBot_EmergIncRange[HEALBOT_ROGUE]=HealBot_Config.EmergIncRangePvE[HEALBOT_ROGUE];
  HealBot_EmergIncRange[HEALBOT_SHAMAN]=HealBot_Config.EmergIncRangePvE[HEALBOT_SHAMAN];
  HealBot_EmergIncRange[HEALBOT_WARLOCK]=HealBot_Config.EmergIncRangePvE[HEALBOT_WARLOCK];
  HealBot_EmergIncRange[HEALBOT_WARRIOR]=HealBot_Config.EmergIncRangePvE[HEALBOT_WARRIOR];
  HealBot_EmergIncHealers[HEALBOT_DRUID]=HealBot_Config.EmergIncHealersPvE[HEALBOT_DRUID];
  HealBot_EmergIncHealers[HEALBOT_HUNTER]=HealBot_Config.EmergIncHealersPvE[HEALBOT_HUNTER];
  HealBot_EmergIncHealers[HEALBOT_MAGE]=HealBot_Config.EmergIncHealersPvE[HEALBOT_MAGE];
  HealBot_EmergIncHealers[HEALBOT_PALADIN]=HealBot_Config.EmergIncHealersPvE[HEALBOT_PALADIN];
  HealBot_EmergIncHealers[HEALBOT_PRIEST]=HealBot_Config.EmergIncHealersPvE[HEALBOT_PRIEST];
  HealBot_EmergIncHealers[HEALBOT_ROGUE]=HealBot_Config.EmergIncHealersPvE[HEALBOT_ROGUE];
  HealBot_EmergIncHealers[HEALBOT_SHAMAN]=HealBot_Config.EmergIncHealersPvE[HEALBOT_SHAMAN];
  HealBot_EmergIncHealers[HEALBOT_WARLOCK]=HealBot_Config.EmergIncHealersPvE[HEALBOT_WARLOCK];
  HealBot_EmergIncHealers[HEALBOT_WARRIOR]=HealBot_Config.EmergIncHealersPvE[HEALBOT_WARRIOR];
  HealBot_EmergIncCustom[HEALBOT_DRUID]=HealBot_Config.EmergIncCustomPvE[HEALBOT_DRUID];
  HealBot_EmergIncCustom[HEALBOT_HUNTER]=HealBot_Config.EmergIncCustomPvE[HEALBOT_HUNTER];
  HealBot_EmergIncCustom[HEALBOT_MAGE]=HealBot_Config.EmergIncCustomPvE[HEALBOT_MAGE];
  HealBot_EmergIncCustom[HEALBOT_PALADIN]=HealBot_Config.EmergIncCustomPvE[HEALBOT_PALADIN];
  HealBot_EmergIncCustom[HEALBOT_PRIEST]=HealBot_Config.EmergIncCustomPvE[HEALBOT_PRIEST];
  HealBot_EmergIncCustom[HEALBOT_ROGUE]=HealBot_Config.EmergIncCustomPvE[HEALBOT_ROGUE];
  HealBot_EmergIncCustom[HEALBOT_SHAMAN]=HealBot_Config.EmergIncCustomPvE[HEALBOT_SHAMAN];
  HealBot_EmergIncCustom[HEALBOT_WARLOCK]=HealBot_Config.EmergIncCustomPvE[HEALBOT_WARLOCK];
  HealBot_EmergIncCustom[HEALBOT_WARRIOR]=HealBot_Config.EmergIncCustomPvE[HEALBOT_WARRIOR];
end

function HealBot_Options_EFClass_SetPvP()
  HealBot_EmergIncMelee[HEALBOT_DRUID]=HealBot_Config.EmergIncMeleePvP[HEALBOT_DRUID];
  HealBot_EmergIncMelee[HEALBOT_HUNTER]=HealBot_Config.EmergIncMeleePvP[HEALBOT_HUNTER];
  HealBot_EmergIncMelee[HEALBOT_MAGE]=HealBot_Config.EmergIncMeleePvP[HEALBOT_MAGE];
  HealBot_EmergIncMelee[HEALBOT_PALADIN]=HealBot_Config.EmergIncMeleePvP[HEALBOT_PALADIN];
  HealBot_EmergIncMelee[HEALBOT_PRIEST]=HealBot_Config.EmergIncMeleePvP[HEALBOT_PRIEST];
  HealBot_EmergIncMelee[HEALBOT_ROGUE]=HealBot_Config.EmergIncMeleePvP[HEALBOT_ROGUE];
  HealBot_EmergIncMelee[HEALBOT_SHAMAN]=HealBot_Config.EmergIncMeleePvP[HEALBOT_SHAMAN];
  HealBot_EmergIncMelee[HEALBOT_WARLOCK]=HealBot_Config.EmergIncMeleePvP[HEALBOT_WARLOCK];
  HealBot_EmergIncMelee[HEALBOT_WARRIOR]=HealBot_Config.EmergIncMeleePvP[HEALBOT_WARRIOR];
  HealBot_EmergIncRange[HEALBOT_DRUID]=HealBot_Config.EmergIncRangePvP[HEALBOT_DRUID];
  HealBot_EmergIncRange[HEALBOT_HUNTER]=HealBot_Config.EmergIncRangePvP[HEALBOT_HUNTER];
  HealBot_EmergIncRange[HEALBOT_MAGE]=HealBot_Config.EmergIncRangePvP[HEALBOT_MAGE];
  HealBot_EmergIncRange[HEALBOT_PALADIN]=HealBot_Config.EmergIncRangePvP[HEALBOT_PALADIN];
  HealBot_EmergIncRange[HEALBOT_PRIEST]=HealBot_Config.EmergIncRangePvP[HEALBOT_PRIEST];
  HealBot_EmergIncRange[HEALBOT_ROGUE]=HealBot_Config.EmergIncRangePvP[HEALBOT_ROGUE];
  HealBot_EmergIncRange[HEALBOT_SHAMAN]=HealBot_Config.EmergIncRangePvP[HEALBOT_SHAMAN];
  HealBot_EmergIncRange[HEALBOT_WARLOCK]=HealBot_Config.EmergIncRangePvP[HEALBOT_WARLOCK];
  HealBot_EmergIncRange[HEALBOT_WARRIOR]=HealBot_Config.EmergIncRangePvP[HEALBOT_WARRIOR];
  HealBot_EmergIncHealers[HEALBOT_DRUID]=HealBot_Config.EmergIncHealersPvP[HEALBOT_DRUID];
  HealBot_EmergIncHealers[HEALBOT_HUNTER]=HealBot_Config.EmergIncHealersPvP[HEALBOT_HUNTER];
  HealBot_EmergIncHealers[HEALBOT_MAGE]=HealBot_Config.EmergIncHealersPvP[HEALBOT_MAGE];
  HealBot_EmergIncHealers[HEALBOT_PALADIN]=HealBot_Config.EmergIncHealersPvP[HEALBOT_PALADIN];
  HealBot_EmergIncHealers[HEALBOT_PRIEST]=HealBot_Config.EmergIncHealersPvP[HEALBOT_PRIEST];
  HealBot_EmergIncHealers[HEALBOT_ROGUE]=HealBot_Config.EmergIncHealersPvP[HEALBOT_ROGUE];
  HealBot_EmergIncHealers[HEALBOT_SHAMAN]=HealBot_Config.EmergIncHealersPvP[HEALBOT_SHAMAN];
  HealBot_EmergIncHealers[HEALBOT_WARLOCK]=HealBot_Config.EmergIncHealersPvP[HEALBOT_WARLOCK];
  HealBot_EmergIncHealers[HEALBOT_WARRIOR]=HealBot_Config.EmergIncHealersPvP[HEALBOT_WARRIOR];
  HealBot_EmergIncCustom[HEALBOT_DRUID]=HealBot_Config.EmergIncCustomPvP[HEALBOT_DRUID];
  HealBot_EmergIncCustom[HEALBOT_HUNTER]=HealBot_Config.EmergIncCustomPvP[HEALBOT_HUNTER];
  HealBot_EmergIncCustom[HEALBOT_MAGE]=HealBot_Config.EmergIncCustomPvP[HEALBOT_MAGE];
  HealBot_EmergIncCustom[HEALBOT_PALADIN]=HealBot_Config.EmergIncCustomPvP[HEALBOT_PALADIN];
  HealBot_EmergIncCustom[HEALBOT_PRIEST]=HealBot_Config.EmergIncCustomPvP[HEALBOT_PRIEST];
  HealBot_EmergIncCustom[HEALBOT_ROGUE]=HealBot_Config.EmergIncCustomPvP[HEALBOT_ROGUE];
  HealBot_EmergIncCustom[HEALBOT_SHAMAN]=HealBot_Config.EmergIncCustomPvP[HEALBOT_SHAMAN];
  HealBot_EmergIncCustom[HEALBOT_WARLOCK]=HealBot_Config.EmergIncCustomPvP[HEALBOT_WARLOCK];
  HealBot_EmergIncCustom[HEALBOT_WARRIOR]=HealBot_Config.EmergIncCustomPvP[HEALBOT_WARRIOR];
end

--------------------------------------------------------------------------------

local HealBot_Options_EmergencyFilter_List = {
  HEALBOT_CLASSES_ALL,
  HEALBOT_DRUID,
  HEALBOT_HUNTER,
  HEALBOT_MAGE,
  HEALBOT_PALADIN,
  HEALBOT_PRIEST,
  HEALBOT_ROGUE,
  HEALBOT_SHAMAN,
  HEALBOT_WARLOCK,
  HEALBOT_WARRIOR,
  HEALBOT_CLASSES_MELEE,
  HEALBOT_CLASSES_RANGES,
  HEALBOT_CLASSES_HEALERS,
  HEALBOT_CLASSES_CUSTOM,
}

function HealBot_Options_EmergencyFilter_DropDown()
  for i=1, getn(HealBot_Options_EmergencyFilter_List), 1 do
    local info = {};
    info.text = HealBot_Options_EmergencyFilter_List[i];
    info.func = HealBot_Options_EmergencyFilter_OnSelect;
    UIDropDownMenu_AddButton(info);
  end
end

function HealBot_Options_EmergencyFilter_Initialize()
  UIDropDownMenu_Initialize(HealBot_Options_EmergencyFilter,HealBot_Options_EmergencyFilter_DropDown)
end

function HealBot_Options_EmergencyFilter_Refresh(onselect)
  if not HealBot_EmergIncMonitor then return end
  if not onselect then HealBot_Options_EmergencyFilter_Initialize() end  -- or wrong menu may be used !
  UIDropDownMenu_SetSelectedID(HealBot_Options_EmergencyFilter,HealBot_EmergIncMonitor)
end

function HealBot_Options_EmergencyFilter_OnLoad(this)
  HealBot_Options_EmergencyFilter_Initialize()
  UIDropDownMenu_SetWidth(100)
end

function HealBot_Options_EmergencyFilter_OnSelect()
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.EmergIncMonitorPvE = this:GetID()
    HealBot_EmergIncMonitor=HealBot_Config.EmergIncMonitorPvE;
  else
    HealBot_Config.EmergIncMonitorPvP = this:GetID()
    HealBot_EmergIncMonitor=HealBot_Config.EmergIncMonitorPvP;
  end
  HealBot_Options_EmergencyFilter_Refresh(true)
  
  HealBot_EmergIncDruid = 0;
  HealBot_EmergIncHunter = 0;
  HealBot_EmergIncMage = 0;
  HealBot_EmergIncPaladin = 0;
  HealBot_EmergIncPriest = 0;
  HealBot_EmergIncRogue = 0;
  HealBot_EmergIncShaman = 0;
  HealBot_EmergIncWarlock = 0;
  HealBot_EmergIncWarrior = 0;
  if HealBot_EmergIncMonitor==1 then
    HealBot_EmergIncDruid = 1;
    HealBot_EmergIncHunter = 1;
    HealBot_EmergIncMage = 1;
    HealBot_EmergIncPaladin = 1;
    HealBot_EmergIncPriest = 1;
    HealBot_EmergIncRogue = 1;
    HealBot_EmergIncShaman = 1;
    HealBot_EmergIncWarlock = 1;
    HealBot_EmergIncWarrior = 1;
  elseif HealBot_EmergIncMonitor==2 then
    HealBot_EmergIncDruid = 1;
  elseif HealBot_EmergIncMonitor==3 then
    HealBot_EmergIncHunter = 1;
  elseif HealBot_EmergIncMonitor==4 then
    HealBot_EmergIncMage = 1;
  elseif HealBot_EmergIncMonitor==5 then
    HealBot_EmergIncPaladin = 1;
  elseif HealBot_EmergIncMonitor==6 then
    HealBot_EmergIncPriest = 1;
  elseif HealBot_EmergIncMonitor==7 then
    HealBot_EmergIncRogue = 1;
  elseif HealBot_EmergIncMonitor==8 then
    HealBot_EmergIncShaman = 1;
  elseif HealBot_EmergIncMonitor==9 then
    HealBot_EmergIncWarlock = 1;
  elseif HealBot_EmergIncMonitor==10 then
    HealBot_EmergIncWarrior = 1;
  elseif HealBot_EmergIncMonitor==11 then
    HealBot_EmergIncDruid = HealBot_EmergIncMelee[HEALBOT_DRUID];
    HealBot_EmergIncHunter = HealBot_EmergIncMelee[HEALBOT_HUNTER];
    HealBot_EmergIncMage = HealBot_EmergIncMelee[HEALBOT_MAGE];
    HealBot_EmergIncPaladin = HealBot_EmergIncMelee[HEALBOT_PALADIN];
    HealBot_EmergIncPriest = HealBot_EmergIncMelee[HEALBOT_PRIEST];
    HealBot_EmergIncRogue = HealBot_EmergIncMelee[HEALBOT_ROGUE];
    HealBot_EmergIncShaman = HealBot_EmergIncMelee[HEALBOT_SHAMAN];
    HealBot_EmergIncWarlock = HealBot_EmergIncMelee[HEALBOT_WARLOCK];
    HealBot_EmergIncWarrior = HealBot_EmergIncMelee[HEALBOT_WARRIOR];
  elseif HealBot_EmergIncMonitor==12 then
    HealBot_EmergIncDruid = HealBot_EmergIncRange[HEALBOT_DRUID];
    HealBot_EmergIncHunter = HealBot_EmergIncRange[HEALBOT_HUNTER];
    HealBot_EmergIncMage = HealBot_EmergIncRange[HEALBOT_MAGE];
    HealBot_EmergIncPaladin = HealBot_EmergIncRange[HEALBOT_PALADIN];
    HealBot_EmergIncPriest = HealBot_EmergIncRange[HEALBOT_PRIEST];
    HealBot_EmergIncRogue = HealBot_EmergIncRange[HEALBOT_ROGUE];
    HealBot_EmergIncShaman = HealBot_EmergIncRange[HEALBOT_SHAMAN];
    HealBot_EmergIncWarlock = HealBot_EmergIncRange[HEALBOT_WARLOCK];
    HealBot_EmergIncWarrior = HealBot_EmergIncRange[HEALBOT_WARRIOR];
  elseif HealBot_EmergIncMonitor==13 then
    HealBot_EmergIncDruid = HealBot_EmergIncHealers[HEALBOT_DRUID];
    HealBot_EmergIncHunter = HealBot_EmergIncHealers[HEALBOT_HUNTER];
    HealBot_EmergIncMage = HealBot_EmergIncHealers[HEALBOT_MAGE];
    HealBot_EmergIncPaladin = HealBot_EmergIncHealers[HEALBOT_PALADIN];
    HealBot_EmergIncPriest = HealBot_EmergIncHealers[HEALBOT_PRIEST];
    HealBot_EmergIncRogue = HealBot_EmergIncHealers[HEALBOT_ROGUE];
    HealBot_EmergIncShaman = HealBot_EmergIncHealers[HEALBOT_SHAMAN];
    HealBot_EmergIncWarlock = HealBot_EmergIncHealers[HEALBOT_WARLOCK];
    HealBot_EmergIncWarrior = HealBot_EmergIncHealers[HEALBOT_WARRIOR];
  elseif HealBot_EmergIncMonitor==14 then
    HealBot_EmergIncDruid = HealBot_EmergIncCustom[HEALBOT_DRUID];
    HealBot_EmergIncHunter = HealBot_EmergIncCustom[HEALBOT_HUNTER];
    HealBot_EmergIncMage = HealBot_EmergIncCustom[HEALBOT_MAGE];
    HealBot_EmergIncPaladin = HealBot_EmergIncCustom[HEALBOT_PALADIN];
    HealBot_EmergIncPriest = HealBot_EmergIncCustom[HEALBOT_PRIEST];
    HealBot_EmergIncRogue = HealBot_EmergIncCustom[HEALBOT_ROGUE];
    HealBot_EmergIncShaman = HealBot_EmergIncCustom[HEALBOT_SHAMAN];
    HealBot_EmergIncWarlock = HealBot_EmergIncCustom[HEALBOT_WARLOCK];
    HealBot_EmergIncWarrior = HealBot_EmergIncCustom[HEALBOT_WARRIOR];
  end

  HealBot_Action_PartyChanged()
end

--------------------------------------------------------------------------------


local HealBot_Options_HealBot_Profile_List = {
  HEALBOT_OPTIONS_ProfilePvE,
  HEALBOT_OPTIONS_ProfilePvP,
}

function HealBot_Options_HealBot_Profile_DropDown()
  for i=1, getn(HealBot_Options_HealBot_Profile_List), 1 do
    local info = {};
    info.text = HealBot_Options_HealBot_Profile_List[i];
    info.func = HealBot_Options_HealBot_Profile_OnSelect;
    UIDropDownMenu_AddButton(info);
  end
end

function HealBot_Options_HealBot_Profile_Initialize()
  UIDropDownMenu_Initialize(HealBot_Options_HealBot_Profile,HealBot_Options_HealBot_Profile_DropDown)
end

function HealBot_Options_HealBot_Profile_Refresh(onselect)
  if not onselect then HealBot_Options_HealBot_Profile_Initialize() end  -- or wrong menu may be used !
  UIDropDownMenu_SetSelectedID(HealBot_Options_HealBot_Profile,HealBot_Config.HealBot_Profile)
end

function HealBot_Options_HealBot_Profile_OnLoad(this)
  HealBot_Options_HealBot_Profile_Initialize()
  UIDropDownMenu_SetWidth(100)
end

function HealBot_Options_HealBot_Profile_OnSelect()
  HealBot_Config.HealBot_Profile = this:GetID()
  HealBot_Options_HealBot_Profile_Refresh(true)
  HealBot_Options_HealBot_Profile_Change(HealBot_Config.HealBot_Profile)
  HealBot_RecalcSpells();
end

function HealBot_Options_HealBot_Profile_Change(flag)
  if flag == 1 then
    HealBot_ActionAlpha=HealBot_Config.ActionAlphaPvE;
    HealBot_BarAlpha=HealBot_Config.BarAlphaPvE;
    HealBot_ActionLocked=HealBot_Config.ActionLockedPvE;
    HealBot_HealthPct=HealBot_Config.HealthPctPvE;
    HealBot_AlertLevel=HealBot_Config.AlertLevelPvE;
    HealBot_EmergencyLevel=HealBot_Config.EmergencyLevelPvE;
    HealBot_AutoShow=HealBot_Config.AutoShowPvE;
    HealBot_PanelSounds=HealBot_Config.PanelSoundsPvE;
    HealBot_AlertSeconds=HealBot_Config.AlertSecondsPvE;
    HealBot_GroupHeals=HealBot_Config.GroupHealsPvE;
    HealBot_TankHeals=HealBot_Config.TankHealsPvE;
    HealBot_TargetHeals=HealBot_Config.TargetHealsPvE;
    HealBot_EmergencyHeals=HealBot_Config.EmergencyHealsPvE;
    HealBot_HealingUsage=HealBot_Config.HealingUsagePvE;
    HealBot_ManaReserve=HealBot_Config.ManaReservePvE;
    HealBot_OverHeal=HealBot_Config.OverHealPvE;
    HealBot_Options_UseHealing_Profile_Change(flag);
    if HealBot_Config.CastNotifyPvP>0 then
      getglobal("HealBot_Options_CastNotify"..HealBot_Config.CastNotifyPvP):SetChecked(nil);
    end
    HealBot_CastNotify=HealBot_Config.CastNotifyPvE;
    HealBot_HideOptions=HealBot_Config.HideOptionsPvE;
    HealBot_ShowTooltip=HealBot_Config.ShowTooltipPvE;
    HealBot_GrowUpwards=HealBot_Config.GrowUpwardsPvE;
    HealBot_QualityRange=HealBot_Config.QualityRangePvE;
    HealBot_EmergRange=HealBot_Config.EmergRangePvE;
    HealBot_IntegrateCTRA=HealBot_Config.IntegrateCTRAPvE;
    HealBot_ToggleAltUse=HealBot_Config.ToggleAltUsePvE;
    HealBot_ProtectPvP=HealBot_Config.ProtectPvPPvE;
    HealBot_EmergencySort=HealBot_Config.EmergencySortPvE;
    HealBot_EmergIncMonitor=HealBot_Config.EmergIncMonitorPvE;
    HealBot_EmergencyFClass=HealBot_Config.EmergencyFClassPvE;
    HealBot_Options_EFClass_SetPvE();
    HealBot_Options_ComboClass_Profile_Change(flag)
    HealBot_EnableHealthy=HealBot_Config.EnableHealthyPvE;
  else
    HealBot_ActionAlpha=HealBot_Config.ActionAlphaPvP;
    HealBot_BarAlpha=HealBot_Config.BarAlphaPvP;
    HealBot_ActionLocked=HealBot_Config.ActionLockedPvP;
    HealBot_HealthPct=HealBot_Config.HealthPctPvP;
    HealBot_AlertLevel=HealBot_Config.AlertLevelPvP;
    HealBot_EmergencyLevel=HealBot_Config.EmergencyLevelPvP;
    HealBot_AutoShow=HealBot_Config.AutoShowPvP;
    HealBot_PanelSounds=HealBot_Config.PanelSoundsPvP;
    HealBot_AlertSeconds=HealBot_Config.AlertSecondsPvP;
    HealBot_GroupHeals=HealBot_Config.GroupHealsPvP;
    HealBot_TankHeals=HealBot_Config.TankHealsPvP;
    HealBot_TargetHeals=HealBot_Config.TargetHealsPvP;
    HealBot_EmergencyHeals=HealBot_Config.EmergencyHealsPvP;
    HealBot_HealingUsage=HealBot_Config.HealingUsagePvP;
    HealBot_ManaReserve=HealBot_Config.ManaReservePvP;
    HealBot_OverHeal=HealBot_Config.OverHealPvP;
    HealBot_Options_UseHealing_Profile_Change(flag);
    if HealBot_Config.CastNotifyPvE>0 then
      getglobal("HealBot_Options_CastNotify"..HealBot_Config.CastNotifyPvE):SetChecked(nil);
    end
    HealBot_CastNotify=HealBot_Config.CastNotifyPvP;
    HealBot_HideOptions=HealBot_Config.HideOptionsPvP;
    HealBot_ShowTooltip=HealBot_Config.ShowTooltipPvP;
    HealBot_GrowUpwards=HealBot_Config.GrowUpwardsPvP;
    HealBot_QualityRange=HealBot_Config.QualityRangePvP;
    HealBot_EmergRange=HealBot_Config.EmergRangePvP;
    HealBot_IntegrateCTRA=HealBot_Config.IntegrateCTRAPvP;
    HealBot_ToggleAltUse=HealBot_Config.ToggleAltUsePvP;
    HealBot_ProtectPvP=HealBot_Config.ProtectPvPPvP;
    HealBot_EmergencySort=HealBot_Config.EmergencySortPvP;
    HealBot_EmergIncMonitor=HealBot_Config.EmergIncMonitorPvP;
    HealBot_EmergencyFClass=HealBot_Config.EmergencyFClassPvP;
    HealBot_Options_EFClass_SetPvP();
    HealBot_Options_ComboClass_Profile_Change(flag);
    HealBot_EnableHealthy=HealBot_Config.EnableHealthyPvP;
  end
  HealBot_Options_ActionAlpha:SetValue(HealBot_ActionAlpha);
  HealBot_Options_BarAlpha:SetValue(HealBot_BarAlpha);
  HealBot_Options_ActionLocked:SetChecked(HealBot_ActionLocked);
  HealBot_Options_HealthPct:SetValue(HealBot_HealthPct);
  HealBot_Options_AlertLevel:SetValue(HealBot_AlertLevel);
  HealBot_Options_EmergencyLevel:SetValue(HealBot_EmergencyLevel);
  HealBot_Options_AutoShow:SetChecked(HealBot_AutoShow);
  HealBot_Options_PanelSounds:SetChecked(HealBot_PanelSounds);
  HealBot_Options_AlertSeconds:SetValue(HealBot_AlertSeconds);
  HealBot_Options_GroupHeals:SetChecked(HealBot_GroupHeals);
  HealBot_Options_TankHeals:SetChecked(HealBot_TankHeals);
  HealBot_Options_TargetHeals:SetChecked(HealBot_TargetHeals);
  HealBot_Options_EmergencyHeals:SetChecked(HealBot_EmergencyHeals);
  HealBot_Options_HealingUsage:SetValue(HealBot_HealingUsage);
  HealBot_Options_ManaReserve:SetValue(HealBot_ManaReserve);
  HealBot_Options_OverHeal:SetValue(HealBot_OverHeal);
  for i=1,17 do
    local ctl = getglobal("HealBot_Options_UseHealing"..i);
    ctl:SetChecked(HealBot_UseHealing[ctl.text]);
  end
  HealBot_Options_CastNotify_OnClick(nil,HealBot_CastNotify);
  HealBot_Options_HideOptions:SetChecked(HealBot_HideOptions);
  HealBot_Options_ShowTooltip:SetChecked(HealBot_ShowTooltip);
  HealBot_Options_GrowUpwards:SetChecked(HealBot_GrowUpwards);
  HealBot_Options_QualityRange:SetChecked(HealBot_QualityRange);
  HealBot_Options_EmergRange:SetChecked(HealBot_EmergRange);
  HealBot_Options_IntegrateCTRA:SetChecked(HealBot_IntegrateCTRA);
  HealBot_Options_ToggleAltUse:SetChecked(HealBot_ToggleAltUse);
  HealBot_Options_ProtectPvP:SetChecked(HealBot_ProtectPvP);
  HealBot_Options_EmergencySort_Refresh();
  HealBot_Options_EmergencyFilter_Refresh();
  HealBot_Options_EmergencyFClass_Refresh();
  HealBot_Options_EFClass_Reset();
  HealBot_Options_ComboClass_Refresh();
  HealBot_Options_EnableHealthy:SetChecked(HealBot_EnableHealthy);
end

function HealBot_Options_UseHealing_Profile_Change(flag)
    for i=1,17 do
      local ctl = getglobal("HealBot_Options_UseHealing"..i);
      if flag==1 then
        HealBot_UseHealing[ctl.text]=HealBot_Config.UseHealingPvE[ctl.text];
      else
        HealBot_UseHealing[ctl.text]=HealBot_Config.UseHealingPvP[ctl.text];
      end
    end
end

--------------------------------------------------------------------------------

local HealBot_Options_ComboClass_List = {
  HEALBOT_DRUID,
  HEALBOT_HUNTER,
  HEALBOT_MAGE,
  HEALBOT_PALADIN,
  HEALBOT_ROGUE,
  HEALBOT_PRIEST,
  HEALBOT_SHAMAN,
  HEALBOT_WARLOCK,
  HEALBOT_WARRIOR,
}

function HealBot_Options_ComboClass_Profile_Change(flag)
  for i=1, getn(HealBot_Options_ComboClass_List), 1 do
    if flag==1 then
      HealBot_KeyCombo[HealBot_Options_ComboClass_List[i]]=HealBot_Config.KeyComboPvE[HealBot_Options_ComboClass_List[i]];
    else
      HealBot_KeyCombo[HealBot_Options_ComboClass_List[i]]=HealBot_Config.KeyComboPvP[HealBot_Options_ComboClass_List[i]];
    end
  end
end

function HealBot_Options_ComboClass_DropDown()
  for i=1, getn(HealBot_Options_ComboClass_List), 1 do
    local info = {};
    info.text = HealBot_Options_ComboClass_List[i];
    info.func = HealBot_Options_ComboClass_OnSelect;
    UIDropDownMenu_AddButton(info);
  end
end

function HealBot_Options_ComboClass_Initialize()
  UIDropDownMenu_Initialize(HealBot_Options_ComboClass,HealBot_Options_ComboClass_DropDown)
  HealBot_Options_ComboClass.class = 1
  local class = UnitClass("player")
  for i=1, getn(HealBot_Options_ComboClass_List), 1 do
    if class==HealBot_Options_ComboClass_List[i] then
      HealBot_Options_ComboClass.class = i
      break
    end
  end
end

function HealBot_Options_ComboClass_Refresh(onselect)
  if not HealBot_Options_ComboClass.class then return end
  if not onselect then HealBot_Options_ComboClass_Initialize() end  -- or wrong menu may be used !
  UIDropDownMenu_SetSelectedID(HealBot_Options_ComboClass,HealBot_Options_ComboClass.class)
  local combo = HealBot_KeyCombo[HealBot_Options_ComboClassText:GetText()]
  if combo then
    HealBot_Options_ShiftLeft:SetText(combo["ShiftLeft"] or "")
    HealBot_Options_CtrlLeft:SetText(combo["CtrlLeft"] or "")
    HealBot_Options_ShiftCtrlLeft:SetText(combo["ShiftCtrlLeft"] or "")
  end
end

function HealBot_Options_ComboClass_OnLoad(this)
  HealBot_Options_ComboClass_Initialize()
  UIDropDownMenu_SetWidth(80)
end

function HealBot_Options_ComboClass_OnSelect()
  HealBot_Options_ComboClass.class = this:GetID()
  HealBot_Options_ComboClass_Refresh(true)
--  HealBot_Action_PartyChanged()
end

--------------------------------------------------------------------------------

function HealBot_Options_EditBox_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_ShiftLeft_OnTextChanged(this)
  local combo = HealBot_KeyCombo[HealBot_Options_ComboClassText:GetText()]
  combo["ShiftLeft"] = this:GetText()
  HealBot_Options_KeyCombo_Change()
end

function HealBot_Options_CtrlLeft_OnTextChanged(this)
  local combo = HealBot_KeyCombo[HealBot_Options_ComboClassText:GetText()]
  combo["CtrlLeft"] = this:GetText()
  HealBot_Options_KeyCombo_Change()
end

function HealBot_Options_ShiftCtrlLeft_OnTextChanged(this)
  local combo = HealBot_KeyCombo[HealBot_Options_ComboClassText:GetText()]
  combo["ShiftCtrlLeft"] = this:GetText()
  HealBot_Options_KeyCombo_Change()
end

function HealBot_Options_KeyCombo_Change()
  if HealBot_Config.HealBot_Profile==1 then
    HealBot_Config.KeyComboPvE[HealBot_Options_ComboClassText:GetText()]=HealBot_KeyCombo[HealBot_Options_ComboClassText:GetText()];
  else
    HealBot_Config.KeyComboPvP[HealBot_Options_ComboClassText:GetText()]=HealBot_KeyCombo[HealBot_Options_ComboClassText:GetText()];
  end
end

function HealBot_Options_EnableHealthy_OnLoad(this,text)
  getglobal(this:GetName().."Text"):SetText(text);
end

function HealBot_Options_EnableHealthy_OnClick(this)
  HealBot_EnableHealthy = this:GetChecked() or 0;
  HealBot_Action_EnableButtons();
end

--------------------------------------------------------------------------------

function HealBot_Options_Defaults_OnClick(this)
  HealBot_Options_CastNotify_OnClick(nil,0);
--  HealBot_Config = HealBot_ConfigDefaults;
  table.foreach(HealBot_ConfigDefaults, function (key,val)
    HealBot_Config[key] = val;
  end);
  HealBot_Options_HealBot_Profile_Change(HealBot_Config.HealBot_Profile);
  HealBot_Options_OnShow(HealBot_Options);
  HealBot_RecalcSpells();
  HealBot_Action_Reset();
  HealBot_ActionVisible = HealBot_Action:IsVisible();
end

function HealBot_Options_OnLoad(this)
  table.insert(UISpecialFrames,this:GetName());

  -- Tabs
  PanelTemplates_SetNumTabs(this,5);
  this.selectedTab = 1;  --gGroupCalendar_CurrentPanel;
  PanelTemplates_UpdateTabs(this);
  HealBot_Options_ShowPanel(this.selectedTab);
end

function HealBot_Options_OnShow(this)
  HealBot_Options_ActionAlpha:SetValue(HealBot_ActionAlpha);
  HealBot_Options_BarAlpha:SetValue(HealBot_BarAlpha);
  HealBot_Options_ActionLocked:SetChecked(HealBot_ActionLocked);
  HealBot_Options_HealthPct:SetValue(HealBot_HealthPct);
  HealBot_Options_AlertLevel:SetValue(HealBot_AlertLevel);
  HealBot_Options_EmergencyLevel:SetValue(HealBot_EmergencyLevel);
  HealBot_Options_AutoShow:SetChecked(HealBot_AutoShow);
  HealBot_Options_PanelSounds:SetChecked(HealBot_PanelSounds);
  HealBot_Options_AlertSeconds:SetValue(HealBot_AlertSeconds);
  HealBot_Options_GroupHeals:SetChecked(HealBot_GroupHeals);
  HealBot_Options_TankHeals:SetChecked(HealBot_TankHeals);
  HealBot_Options_TargetHeals:SetChecked(HealBot_TargetHeals);
  HealBot_Options_EmergencyHeals:SetChecked(HealBot_EmergencyHeals);
  HealBot_Options_HealingUsage:SetValue(HealBot_HealingUsage);
  HealBot_Options_ManaReserve:SetValue(HealBot_ManaReserve);
  HealBot_Options_OverHeal:SetValue(HealBot_OverHeal);
  for i=1,17 do
    local ctl = getglobal("HealBot_Options_UseHealing"..i);
    ctl:SetChecked(HealBot_UseHealing[ctl.text]);
  end
  HealBot_Options_CastNotify_OnClick(nil,HealBot_CastNotify);
  HealBot_Options_HideOptions:SetChecked(HealBot_HideOptions);
  HealBot_Options_ShowTooltip:SetChecked(HealBot_ShowTooltip);
  HealBot_Options_GrowUpwards:SetChecked(HealBot_GrowUpwards);
  HealBot_Options_QualityRange:SetChecked(HealBot_QualityRange);
  HealBot_Options_EmergRange:SetChecked(HealBot_EmergRange);
  HealBot_Options_IntegrateCTRA:SetChecked(HealBot_IntegrateCTRA);
  HealBot_Options_ToggleAltUse:SetChecked(HealBot_ToggleAltUse);
  HealBot_Options_ProtectPvP:SetChecked(HealBot_ProtectPvP);
  HealBot_Options_EmergencySort_Refresh()
  HealBot_Options_EmergencyFilter_Refresh()
  HealBot_Options_EmergencyFClass_Refresh();
    HealBot_Options_EFClass_Reset();
  HealBot_Options_HealBot_Profile_Refresh()
  HealBot_Options_ComboClass_Refresh()
  HealBot_Options_EnableHealthy:SetChecked(HealBot_EnableHealthy);
end

HealBot_Options_CurrentPanel = 0;

function HealBot_Options_ShowPanel(id)
  if HealBot_Options_CurrentPanel>0 then
    getglobal("HealBot_Options_Panel"..HealBot_Options_CurrentPanel):Hide();
  end
  HealBot_Options_CurrentPanel = id;
  if HealBot_Options_CurrentPanel>0 then
    getglobal("HealBot_Options_Panel"..HealBot_Options_CurrentPanel):Show();
  end
end
